Edit Types in EJ2 JavaScript Data Grid

07 Aug 202624 minutes to read

The EJ2 JavaScript Grid control in Syncfusion® provides various edit types that allow you to customize the editing behavior for different types of columns. These edit types enhance the editing experience and provide flexibility in handling different data types.

Default cell edit type editor

The Syncfusion® Grid provides pre-built default editors that enhance data editing and input handling within the grid. These default editors are designed to simplify the process of defining the editor control for specific columns based on the data type of the column within the grid. To configure default editors for grid columns, leverage the editType property.

The available default edit types are as follows:

Control Edit Type value Description
TextBox stringedit The stringedit type renders a TextBox control for string data type columns.
NumericTextBox numericedit The numericedit type renders a NumericTextBox control for integers,double,float ,short ,byte ,long ,long double and decimal data types columns.
DropDownList dropdownedit The dropdownedit type renders a DropdownList control for string data type columns.
Checkbox booleanedit The booleanedit type renders a CheckBox control for boolean data type columns.
DatePicker datepickeredit The datepickeredit type renders a DatePicker control for date data type columns.
DateTimePicker datetimepickeredit The datetimepickeredit type renders a DateTimePicker control for date time data type columns.

The following example demonstrates how to define the editType for grid columns:

    {field: 'CustomerName', headerText: 'Customer Name', editType: 'stringedit'},
    {field: 'Frieght', headerText: 'Frieght', editType: 'numericedit'},
    {field: 'ShipCountry', headerText: 'Ship Country', editType: 'dropdownedit'},
    {field: 'OrderDate', headerText: 'Order Date', editType: 'datepickeredit'},
    {field: 'OrderTime', headerText: 'Order Time', editType: 'datetimepickeredit'},
    {field: 'Verified', headerText: 'Verified', editType: 'booleanedit'}

If edit type is not defined in the column, then it will be considered as the stringedit type (TextBox control) .

Customize TextBox control of stringedit type

You can customize the default TextBox control in Grid edit form using its property. This customization allows you to configure various properties of the TexBox, tailoring its behavior and appearance to match your specific requirements within the Grid. The behavior of the editor control can be fine-tuned through the columns->edit->params property.

control Edit Type Description Example Customized edit params
TextBox stringedit The stringedit type renders a TextBox control for string data type columns. To customize the TextBox control, refer to the TextBox API documentation for detailed information on available properties params: { showClearButton : true}

The following sample code demonstrates the customization applied to TextBox control of CustomerID Grid column:

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
    dataSource: data,
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    height: 265,
    columns: [
        { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', isPrimaryKey: true, width: 100 },
        { field: 'CustomerID', edit: { params: { showClearButton: true } }, headerText: 'Customer ID', width: 120 },
        { field: 'Freight', headerText: 'Freight', textAlign: 'Right', editType: 'numericedit', width: 120 },
        { field: 'ShipCity', headerText: 'Ship City', editType: 'dropdownedit', width: 150 }
    ]
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Customize NumericTextBox control of numericedit type

You can customize the NumericTextBox control in Grid edit form using its property. This customization allows you to configure various properties of the NumericTextBox, tailoring its behavior and appearance to match your specific requirements within the Grid. The behavior of the editor control can be fine-tuned through the columns->edit->params property.

control Edit Type Description Example Customized edit params
NumericTextBox numericedit The numericedit type renders a NumericTextBox control for integers, double, float, short, byte, long, long double and decimal data types columns. To customize the NumericTextBox control, refer to the NumericTextBox API documentation for detailed information on available properties. params: { decimals: 2, value: 5 }

The following sample code demonstrates the customization applied to NumericTextBox control of Freight Grid column:

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
    dataSource: data,
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    height: 265,
    columns: [
        { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', validationRules: { required: true, number: true }, isPrimaryKey: true, width: 100 },
        { field: 'CustomerID', validationRules: { required: true }, headerText: 'CustomerID', width: 120 },
        {
            field: 'Freight', headerText: 'Freight', textAlign: 'Right', editType: 'numericedit', edit: {
                params: {
                    decimals: 0,
                    format: 'N',
                    showClearButton: true,
                    showSpinButton: false
                }
            }, validationRules: { required: true, min: 1, max: 1000 }, width: 120
        },
        { field: 'ShipCity', headerText: 'Ship City', editType: 'dropdownedit', validationRules: { required: true }, width: 150 }
    ]
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Restrict to type decimal points in a NumericTextBox while editing the numeric column

By default, the NumericTextBox control allows entering decimal values with up to two decimal places when editing a numeric column. However, there might be cases where you want to restrict input to whole numbers only, without any decimal points. In such scenarios, you can make use of the validateDecimalOnType and decimals properties provided by Syncfusion’s® NumericTextBox control.

The validateDecimalOnType property is used to control whether decimal points are allowed during input in the NumericTextBox. By default, it is set to false, allowing decimal points to be entered. However, when set to true, decimal points will be restricted, and only whole numbers can be entered.

The decimals property specifies the number of decimal places to be displayed in the NumericTextBox. By default, it is set to 2, meaning that two decimal places will be displayed. However, you can modify this value to customize the decimal places according to your requirements.

In the below demo, while editing the row the decimal point value is restricted to type in the NumericTextBox of Freight column.

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
    dataSource: data,
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
    columns: [
        { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', isPrimaryKey: true, width: 100 },
        { field: 'CustomerID', headerText: 'Customer ID', width: 120 },
        {
            field: 'Freight', headerText: 'Freight', textAlign: 'Right', editType: 'numericedit', width: 150, edit: {
                params: {
                    validateDecimalOnType: true,
                    decimals: 0,
                    format: "N"
                }
            }
        },
        { field: 'ShipCity', headerText: 'Ship City', editType: 'dropdownedit', width: 150 }
    ],
    height: 265
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>        
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Customize DropDownList control of DropDownEdit type

You can customize the DropDownList control in Grid edit form using its property. This customization allows you to configure various properties of the DropDownList, tailoring its behavior and appearance to match your specific requirements within the Grid. The behavior of the editor control can be fine-tuned through the columns->edit->params property.

Control Edit Type Description Example Customized edit params
DropDownList DropDownEdit The dropdownedit type renders a DropDownList control for string data type columns. To customize the DropDownList control, refer to the DropDownList API documentation for detailed information on available properties. params: { value: ‘Germany’ }

The following sample code demonstrates the customization applied to DropDownList control of ShipCity Grid column:

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
    dataSource: data,
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    height: 265,
    columns: [
        { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', isPrimaryKey: true, validationRules: { required: true, number: true }, width: 100 },
        { field: 'CustomerID', headerText: 'CustomerID', validationRules: { required: true }, width: 120 },
        { field: 'Freight', headerText: 'Freight', textAlign: 'Right', editType: 'numericedit', width: 120, validationRules: { required: true, min: 1, max: 1000 } },
        {
            field: 'ShipCity', headerText: 'Ship City', editType: 'dropdownedit', edit: {
                params: {
                    showClearButton: true,
                    popupHeight: 120
                }
            }, validationRules: { required: true }, width: 150
        }
    ]
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Provide custom data source for DropDownList control

In Syncfusion’s® Grid control, you have an option to provide a custom data source for the DropDownList control in the edit form. This feature allows you to define a specific set of values for the DropDownList.

To achieve this, you can utilize the columns->edit->params property. This property allows you to define the edit params for the column within the grid.

When setting a new data source using the edit params, you need to specify a new query property for the DropDownList. The query property allows you to define custom queries for data retrieval and filtering.

In the below demo, DropDownList is rendered with custom data source for the ShipCountry column.

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);

var country =  [
    { countryName: 'United States', countryId: '1' },
    { countryName: 'Australia', countryId: '2' },
    { countryName: 'India', countryId: '3' }
];

var grid = new ej.grids.Grid({
    dataSource: data,
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
    columns: [
        { field: 'OrderID', headerText: 'Order ID', validationRules: { required: true, number: true }, textAlign: 'Right', isPrimaryKey: true, width: 100 },
        { field: 'CustomerID', headerText: 'Customer ID', validationRules: { required: true }, width: 120},
        { field: 'ShipCountry', headerText: 'Ship Country', editType: 'dropdownedit',validationRules: { required: true }, width: 150, edit: { 
                params: {
                    dataSource: new ej.data.DataManager(country),
                    fields: { text: 'countryName', value: 'countryName' },
                    query:  new ej.data.Query(),
                    actionComplete: () => false
                }
            }
        }
    ],
    height: 273
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Apply filtering for DropDownList control

The Syncfusion® Grid control provides filtering for the DropDownList within the edit form. This feature allows to select options from a predefined list and easily search for specific items using the built-in filtering feature.

To enable filtering, set the allowFiltering property to true within the edit params. This will enable the filtering feature in the DropDownList.

In the following demo, filtering is enabled for the ShipCountry column.

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
  dataSource: data,
  editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
  toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
  columns: [
    { field: 'OrderID', headerText: 'Order ID', validationRules: { required: true, number: true }, textAlign: 'Right', isPrimaryKey: true, width: 100 },
    { field: 'CustomerID', headerText: 'Customer ID', validationRules: { required: true }, width: 120 },
    {
      field: 'ShipCountry', headerText: 'Ship Country', editType: 'dropdownedit', validationRules: { required: true }, edit: {
        params: {
          allowFiltering: true,
        }
      }, width: 150
    }
  ],
  height: 273
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Open popup while focusing in the edit cell

You can open the dropdown edit popup with a single click by focusing the dropdown element. This feature allows you to quickly access and interact with the dropdown options without the need for an additional click.

To achieve this, you can utilize the showPopup method provided by the EJ2 DropDownList control. This method can be invoked within the actionComplete event of the Grid, which triggers when an action, such as editing, is completed. By calling the showPopup method in this event, you can open the popup for the dropdown edit.

To ensure that the dropdown column is the clicked edit target, you need to set a global flag variable in the mouseup event along with load event. This flag variable will be used to determine if the clicked element corresponds to the dropdown column.

The following sample demonstrates how to open the popup when focusing on the edit cell using the actionComplete and load events:

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
  dataSource: data,
  editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Normal' },
  toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
  allowPaging: true,
  load: load,
  actionComplete: onActionComplete,
  columns: [
    { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', width: 100, isPrimaryKey: true },
    { field: 'CustomerID', headerText: 'Customer ID', width: 120 },
    { field: 'Freight', headerText: 'Freight', textAlign: 'Right', width: 120, format: 'C2' },
    { field: 'ShipCountry', headerText: 'Ship Country', editType: 'dropdownedit', width: 150 }
  ],
  height: 273
});
grid.appendTo('#Grid');

var isDropdown = false;

function load() {
  grid.element.addEventListener('mouseup', (e) => {
    if (e.target.classList.contains('e-rowcell')) {
      if (grid.isEdit) {
        grid.endEdit();
      }
      var rowInfo = grid.getRowInfo(e.target);
      if (rowInfo && rowInfo.column && (rowInfo.column).field === 'ShipCountry') {
        isDropdown = true;
        grid.selectRow(rowInfo.rowIndex);
        grid.startEdit();
      }
    }
  });
}

function onActionComplete(args) {
  if (args.requestType === 'beginEdit' && isDropdown) {
    isDropdown = false;
    var dropdownObj = (args.form.querySelector('.e-dropdownlist'))['ej2_instances'][0];
    dropdownObj.element.focus();
    dropdownObj.showPopup();
  }
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Customize CheckBox control of booleanedit type

You can customize the CheckBox control in Grid edit form using its property. This customization allows you to configure various properties of the CheckBox, tailoring its behavior and appearance to match your specific requirements within the Grid. The behavior of the editor control can be fine-tuned through the columns->edit->params property.

Control Edit Type Description Example Customized edit params
CheckBox booleanedit The booleanedit type renders a CheckBox control for boolean data type. To customize the CheckBox control, refer to the CheckBox API documentation for detailed information on available properties. params: { checked: true}

The following sample code demonstrates the customization applied to CheckBox control of Verified Grid column:

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
    dataSource: data,
    editSettings:  { allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    columns: [
        { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', isPrimaryKey: true,validationRules: { required: true, number: true }, width: 100 },
        { field: 'CustomerID', headerText: 'Customer ID', width: 120, validationRules: { required: true }},
        { field: 'Freight', headerText: 'Freight', validationRules: { required: true, min: 1, max: 1000 }, textAlign: 'Right', editType: 'numericedit', width: 120},
        { field: 'ShipCity', headerText: 'Ship City', editType: 'dropdownedit', validationRules:  { required: true }, width: 150},
        { field: 'OrderDate', headerText: 'Order Date', width: 100, format: 'yyyy-MM-dd', editType: 'datetimepickeredit', validationRules:  { required: true }},
        { field: 'Verified', headerText: 'Verified', width: 100, displayAsCheckBox: 'true', editType: 'booleanedit', edit: {
            params: {
                disabled: true,
            }
        }}
    ],
    height: 265
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Customize DatePicker control of datepickeredit type

You can customize the DatePicker control in Grid edit form using its property. This customization allows you to configure various properties of the DatePicker, tailoring its behavior and appearance to match your specific requirements within the Grid. The behavior of the editor control can be fine-tuned through the columns->edit->params property.

control Edit Type Description Example Customized edit params
DatePicker datepickeredit The datepickeredit type renders a DatePicker control for date data type columns. To customize the DatePicker control, refer to the DatePicker API documentation for detailed information on available properties. params: { format:’dd.MM.yyyy’ }

The following sample code demonstrates the customization applied to DatePicker control of OrderDate Grid column:

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
    dataSource: data,
    editSettings:  { allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    columns: [
        { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', validationRules: { required: true, number: true }, isPrimaryKey: true, width: 100 },
        { field: 'CustomerID', headerText: 'Customer ID', width: 120, validationRules: { required: true }},
        { field: 'Freight', headerText: 'Freight', validationRules: { required: true, min: 1, max: 1000 }, textAlign: 'Right',editType: 'numericedit', width: 120},
        { field: 'ShipCity', headerText: 'Ship City', editType: 'dropdownedit', validationRules:  { required: true }, width: 150},
        { field: 'OrderDate', headerText: 'Order Date', width: 150, format: 'MM-dd-yyyy', editType: 'datepickeredit', validationRules:  { required: true }, edit: { params: {
            showClearButton: false,
            showTodayButton: false
        }}}
    ],
    height: 265
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Disable the date value prior to the selected date value in DatePicker control

The Syncfusion® Grid allows configuring the DatePicker control to dynamically set a minimum date for selection. This feature ensures that users can select dates only from a specified minimum date onward, based on the context of each row’s data. This functionality is particularly useful in maintaining data accuracy by preventing users from selecting invalid or illogical dates.

The following example demonstrates how to configure the DatePicker control within the grid using the edit parameters of a column. This setup dynamically restricts the selection of dates in the DatePicker’s calendar based on the data in the current row.

var grid = new ej.grids.Grid({
    dataSource: data,
    allowPaging: true,
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    editSettings: { allowAdding: true, allowEditing: true, allowDeleting: true },
    columns: [
      {
        field: 'OrderID',
        headerText: 'Order ID',
        width: 120,
        textAlign: 'Right',
        isPrimaryKey: true,
      },
      { field: 'CustomerID', headerText: 'Customer ID', width: 150 },
      {
        field: 'OrderDate',
        headerText: 'Order Date',
        width: 130,
        format: 'yMd',
        textAlign: 'Right',
        editType: 'datepickeredit',
      },
      {
        field: 'Freight',
        width: 120,
        format: 'C2',
        textAlign: 'Right',
        editType: 'numericedit',
      },
      {
        field: 'ShipCountry',
        headerText: 'Ship Country',
        width: 130
      }
    ],
    pageSettings: { pageCount: 5 },
    actionBegin: function (args) {
      if (args.requestType === 'beginEdit') {
        let minDate = args.rowData['OrderDate'];
        this.columns.forEach((column) => {
          if (column.field === 'OrderDate') {
            column.edit.params = { min: minDate };
          }
        });
      }
    },
  });
  grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    <div id="container">
        <div id="Grid"></div>        
    </div>
<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Customize DateTimePicker control of datetimepickeredit type

You can customize the DateTimePicker control in Grid edit form using its property. This customization allows you to configure various properties of the DateTimePicker, tailoring its behavior and appearance to match your specific requirements within the Grid. The behavior of the editor control can be fine-tuned through the columns->edit->params property.

control Edit Type Description Example Customized edit params
DateTimePicker datetimepickeredit The datetimepickeredit type renders a DateTimePicker control for date time data type columns. You can customize the DateTimePicker control, refer to the DateTimePicker API documentation for detailed information on available properties. params: { value: new Date() }

The following sample code demonstrates the customization applied to DateTimePicker control of OrderDate Grid column:

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
    dataSource: data,
    editSettings:  { allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    columns: [
        { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', validationRules: { required: true, number: true }, isPrimaryKey: true, width: 100 },
        { field: 'CustomerID', headerText: 'Customer ID', width: 120, validationRules: { required: true }},
        { field: 'Freight', headerText: 'Freight', textAlign: 'Right', editType: 'numericedit', width: 120, validationRules: { required: true, min: 1, max: 1000 }},
        { field: 'ShipCity', headerText: 'Ship City', editType: 'dropdownedit', validationRules:  { required: true }, width: 150},
        { field: 'OrderDate', headerText: 'Order Date', width: 150, format: 'MM-dd-yyyy hh mm aa', editType: 'datetimepickeredit', validationRules:  { required: true }, edit: { params: {
            showClearButton : false,
            format:'MM-dd-yyyy hh:mm aa',
            start:'Year',
           }}}
    ],
    height: 265
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Access editor controls using instance

Accessing editor controls in the Syncfusion® Grid allows you to interact with the editor instances associated with cells during editing or adding actions. This feature is especially useful when you need to perform custom actions, retrieve data from the Editor, or manipulate its properties during editing or adding operations in the Grid.

To access the control instance from the control element, you can use the ej2_instances property. This property provides access to the instance of the editor control associated with a cell.

In the below demo, you can access the editor control instance while adding or editing actions in the actionComplete event.

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
    dataSource: data,
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    actionComplete: access,
    columns: [
        { field: 'OrderID', headerText: 'Order ID', isPrimaryKey: true, textAlign: 'Right', width: 100 },
        { field: 'CustomerID', headerText: 'Customer ID', type: 'string', validationRules: { required: true }, width: 120 },
        { field: 'Freight', headerText: 'Freight', textAlign: 'Right', validationRules: { required: true }, format: 'C2', editType: 'numericedit', width: 120 },
        { field: 'ShipCountry', headerText: 'Ship Country', width: 150, editType: 'dropdownedit' }
    ],
    height: 265
});
grid.appendTo('#Grid');

function access(args) {
    if (args.requestType === 'beginEdit' || args.requestType === 'add') {
        var tr = args.row;
        var numericTextBox = tr.querySelector('.e-numerictextbox'); // numeric TextBox control element
        if (numericTextBox) {
            var numericTextBoxInstance = (numericTextBox).ej2_instances[0];
            numericTextBoxInstance.element.style.backgroundColor = 'light pink';
            numericTextBoxInstance.element.style.color = 'black';
            numericTextBoxInstance.element.style.border = '2px solid red';
            numericTextBoxInstance.element.style.textAlign = 'center';
            numericTextBoxInstance.max = 1000;
            numericTextBoxInstance.min = 1;
        }
        var dropDownList = tr.querySelector('.e-dropdownlist'); // dropDownList control element
        if (dropDownList) {
            var dropDownListInstance = (dropDownList).ej2_instances[0]
            dropDownListInstance.showPopup(); // Open the dropdown list
        }
    }
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Render custom cell editors using external function

The Syncfusion® Grid provides the ability to render custom cell editors, allowing you to add custom controls to specific columns in your grid using the cell edit template feature. This feature is useful when you need to edit cell values using custom input elements or controls.

To utilize the custom cell editor template feature, you need to implement the following functions:

  • create - It is used to create the element at the time of initialization.

  • write - It is used to create custom control or assign default value at the time of editing.

  • read - It is used to read the value from the control at the time of save.

  • destroy - It is used to destroy the control.

Render textArea in edit form

The Syncfusion® Grid allows you to render a textArea within the Grid’s edit form for a specific column. This feature is especially valuable when you need to edit and display multi-line text content, providing an efficient way to manage extensive text data within the Grid’s columns.

To render a textArea in the edit form, you need to define a cell edit template for the column using edit property. The edit property specifies the cell edit template that used as an editor for a particular column.

When using a text area, please use Shift+Enter to move to the next line. By default, pressing Enter will trigger a record update while you are in edit mode.

The following example demonstrates how to render a textArea control in the ShipAddress column of the Syncfusion® Grid. The valueAccessor property is utilized to split the text into multiple lines within the grid column:

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);

var textboxElem;
var textboxObject;

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
    dataSource: data,
    allowTextWrap: true,
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    columns: [
        { field: 'OrderID', headerText: 'Order ID', width: 120, textAlign: 'Right', isPrimaryKey: true, validationRules: { required: true } },
        { field: 'CustomerID', headerText: 'Customer Name', width: 120, validationRules: { required: true, minLength: 5 } },
        { field: 'Freight', headerText: 'Freight', width: 120, format: 'C2', textAlign: 'Right', editType: 'numericedit', validationRules: { required: true } },
        { field: 'OrderDate', headerText: 'Order Date', width: 130, editType: 'datepickeredit', format: 'yMd', textAlign: 'Right' },
        {
            field: 'ShipAddress', headerText: 'Ship Country', disableHtmlEncode: false,
            valueAccessor: function (field, data) {
                var value = data.ShipAddress;
                return (value !== undefined) ? value.split('\n').join('<br>') : '';
            }, width: 150,
            edit: {
                create: createShipAddressFn,
                destroy: destroyShipAddressFn,
                read: readShipAddressFn,
                write: writeShipAddressFn
            }
        }
    ],
    height: 265
});
grid.appendTo('#Grid');

function createShipAddressFn() {
    textboxElem = document.createElement('textarea');
    return textboxElem;
}
function destroyShipAddressFn() {
    textboxObject.destroy();
}
function readShipAddressFn() {
    return textboxObject.value;
}

function writeShipAddressFn(args) {
    var rowData = args.rowData;
    textboxObject = new ej.inputs.TextBox({
        multiline: true,
        value: rowData.ShipAddress,
    });
    textboxObject.appendTo(textboxElem);
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Prevent the enter key functionality in multiline textbox while editing

While editing a particular row in normal or dialog edit mode, pressing the ENTER key will save the changes made in the specific cell or edit form. Similarly, pressing the ENTER key while performing editing with the multiline textbox will save the changes. However, in a multiline textbox, it is often desired that pressing the ENTER key adds a new line break in the text content, rather than triggering the save action.

To achieve this behavior, you can utilize the stopPropagation method along with the focus event of the textBox control. This prevents the default behavior of the ENTER key, allowing you to manually handle the newline behavior.

The following example demonstrates how to prevent the enter key functionality in multiline textbox during editing by utilizing the focus event:

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);

var textboxElem;
var textboxObject;

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
    dataSource: data,
    allowTextWrap: true,
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Normal' },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    columns: [
        { field: 'OrderID', headerText: 'Order ID', width: 120, textAlign: 'Right', isPrimaryKey: true, validationRules: { required: true } },
        { field: 'CustomerID', headerText: 'Customer Name', width: 120, validationRules: { required: true, minLength: 5 } },
        { field: 'Freight', headerText: 'Freight', width: 120, format: 'C2', textAlign: 'Right', editType: 'numericedit', validationRules: { required: true } },
        { field: 'OrderDate', headerText: 'Order Date', width: 130, editType: 'datepickeredit', format: 'yMd', textAlign: 'Right' },
        {
            field: 'ShipAddress', headerText: 'Ship Country', disableHtmlEncode: false,
            valueAccessor: function(field, data) {
                var value = data.ShipAddress;
                return (value !== undefined) ? value.split('\n').join('<br>') : '';
            }, width: 150,
            edit: {
                create: createShipAddressFn,
                destroy: destroyShipAddressFn,
                read: readShipAddressFn,
                write: writeShipAddressFn
            }
        }
    ],
    height: 273
});
grid.appendTo('#Grid');

function createShipAddressFn() {
    textboxElem = document.createElement('input');
    return textboxElem;
}
function destroyShipAddressFn() {
    textboxObject.destroy();
}
function readShipAddressFn() {
    return textboxObject.value;
}

function writeShipAddressFn(args) {
    var rowData = args.rowData;
    textboxObject = new ej.inputs.TextBox({
        multiline: true,
        value: rowData.ShipAddress,
        focus:
            function onFocus(args) {
                ((args.event).target).addEventListener('keydown', (e) => {
                    if ((e).key === 'Enter') {
                        e.stopPropagation();
                    }
                });
            }
    });
    textboxObject.appendTo(textboxElem);
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Render MaskedTextBox control in edit form

The Syncfusion® Grid allows you to render a MaskedTextBox control within the Grid’s edit form for a specific column. This feature is especially useful when you need to provide masked input fields that require a specific format, such as phone numbers or postal codes.

To render a MaskedTextBox control in the edit form, you need to define a cell edit template for the column using edit property. The edit property specifies the cell edit template that used as an editor for a particular column.

Here’s an example of how to render a MaskedTextBox control in the CustomerNumber column of the Syncfusion® Grid.

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);

var maskelem;
var maskObj;

var grid = new ej.grids.Grid({
    dataSource: data,
    allowPaging: true,
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    columns: [
        { field: 'OrderID', headerText: 'Order ID', type: 'number', textAlign: 'Right', isPrimaryKey: true, width: 100 },
        { field: 'CustomerID', headerText: 'Customer ID', type: 'string', width: 120 },
        { field: 'ShipCountry', headerText: 'Ship Country', width: 100 },
        { field: 'CustomerNumber', headerText: 'Customer Number', width: 140 , edit: {
                create: function(){
                    maskelem = document.createElement('input');
                    return maskelem;
                },
                read: function() {
                    return maskObj.value;
                },
                destroy: function() {
                    maskObj.destroy();
                },
                write: function(args){
                    var rowData = args.rowData
                    maskObj = new ej.inputs.MaskedTextBox({
                        mask: "000-000-0000",
                        value: rowData.CustomerNumber
                    });
                    maskObj.appendTo(args.element);
                }
            }
        }
    ],
    height: 273
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Render DropDownList control in edit form

The Syncfusion® Grid allows you to render a DropDownList control within the Grid’s edit form for a specific column. This feature is valuable when you need to provide a convenient way to select options from a predefined list while editing data in the Grid’s edit form.

To render a DropDownList control in the edit form, you need to define a cell edit template for the column using edit property. The edit property specifies the cell edit template that used as an editor for a particular column.

The following example demonstrates how to render a DropDownList control in the ShipCountry column of the Syncfusion® Grid.

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);

var dropdownElem;
var dropdownlistObj;

var selectDatasource = [
    { text: 'Germany', value: 'Germany' },
    { text: 'Brazil', value: 'Brazil' },
    { text: 'Belgium', value: 'Belgium' },
    { text: 'Switzerland', value: 'Switzerland' },
    { text: 'Venezuela', value: 'Venezuela' },
    { text: 'Austria', value: 'Austria' },
    { text: 'Mexico', value: 'Mexico' },
    { text: 'France', value: 'France' }
];

var grid = new ej.grids.Grid({
    dataSource: data,
    allowPaging: true,
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    columns: [
        { field: 'OrderID', headerText: 'Order ID', width: 120, textAlign: 'Right', isPrimaryKey: true, validationRules: { required: true } },
        { field: 'CustomerID', headerText: 'Customer Name', width: 120 },
        { field: 'Freight', headerText: 'Freight', width: 120,format: 'C2', textAlign: 'Right', editType: 'numericedit', validationRules: { required: true, min: 1, max: 1000 }},
        { field: 'OrderDate', headerText: 'Order Date', width: 130, editType: 'datepickeredit', format: 'yMd', textAlign: 'Right' },
        { field: 'ShipCountry', headerText: 'Ship Country', width: 150 , edit: {
                create: function(){
                    dropdownElem = document.createElement('input');
                    return dropdownElem;
                },
                read: function() {
                    return dropdownlistObj.value;
                },
                destroy: function() {
                    dropdownlistObj.destroy();
                },
                write: function(args){
                    var rowData = args.rowData;
                    dropdownlistObj = new ej.dropdowns.DropDownList({
                        dataSource: selectDatasource,
                        value: rowData.ShipCountry
                    });
                    dropdownlistObj.appendTo(args.element);
                }
            }
        }
    ],
    height: 273
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Render images in the DropDownList editor control using the item template

The Syncfusion® Grid allows you to render images in the DropDownList editor conttol. This feature is valuable when you want to display images for each item in the dropdown list of a particular column, enhancing the visual representation of your data.

To render a DropDownList in the edit form, you need to define a cell edit template for the column using edit property. The edit property specifies the cell edit template that used as an editor for a particular column.

To display an image in the DropDownList editor control, you can utilize the itemTemplate property. This property allows you to customize the content of each item in the dropdown list.

The following example demonstrates how to render images in the DropDownList editor control using the itemTemplate within the EmployeeName column of the Syncfusion® Grid.

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);

var dropdownlistElem;
var dropdownlistObj;

var grid = new ej.grids.Grid({
    dataSource: data,
    allowPaging: true,
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Normal' },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    columns: [
        { field: 'OrderID', headerText: 'Order ID', width: 120, textAlign: 'Right', validationRules: { required: true }, isPrimaryKey: true },
        {
            field: 'EmployeeID', foreignKeyValue: 'FirstName', foreignKeyField: 'EmployeeID', dataSource: employeeData, headerText: 'Employee Name', width: 220, edit: {
                create: function () {
                    dropdownlistElem = document.createElement('input');
                    return dropdownlistElem;
                },
                read: function () {
                    return dropdownlistObj.value;
                },
                destroy: function () {
                    dropdownlistObj.destroy();
                },
                write: function (args) {
                    var rowData = args.rowData;
                    dropdownlistObj = new ej.dropdowns.DropDownList({
                        dataSource: employeeData,
                        fields: { text: 'FirstName', value: 'EmployeeID' },
                        value: rowData.EmployeeID,
                        change: function (args) {
                            // Update the EmployeeID value in the rowData object
                            rowData.EmployeeID = args.value;
                        },
                        itemTemplate: function (props) {
                            return '<div><img class="empImage" width="50px" src="https://ej2.syncfusion.com/demos/src/grid/images/' + props.EmployeeID + '.png" alt="employee"/><div class="ename">' + props.FirstName + '</div></div>';
                        }
                    });
                    dropdownlistObj.appendTo(args.element);
                }
            }
        },
        { field: 'Freight', headerText: 'Freight', width: 100, format: 'C2', textAlign: 'Right', editType: 'numericedit' },
        { field: 'ShipName', headerText: 'Ship Name', width: 170 },
        { field: 'ShipCountry', headerText: 'Ship Country', width: 150, editType: 'dropdownedit' }
    ],
    height: 273
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Render Multiple columns in DropDownList control

The Syncfusion® Grid allows you to render a DropDownList control within the Grid’s edit form for a specific column. This feature is particularly useful when you want to display more detailed information for each item in the dropdown list during editing a specific column.

To render a DropDownList in the edit form, you need to define a cell edit template for the column using edit property. The edit property specifies the cell edit template that used as an editor for a particular column.

The DropDownList has been provided with several options to customize each list item, group title, selected value, header, and footer element. By default, list items can be rendered as a single column in the DropDownList control. Instead of this, multiple columns can be rendered. This can be achieved by using the headerTemplate and itemTemplate properties of the DropDownList control.

The following example demonstrates how to render a DropDownList control with multiple columns within in the ShipCountry column.

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);

var dropdownlistElem;
var dropdownlistObj;

var grid = new ej.grids.Grid({
    dataSource: data,
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true},
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    columns: [
        { field: 'OrderID', headerText: 'Order ID', width: 120, textAlign: 'Right', isPrimaryKey: true, validationRules: { required: true } },
        { field: 'CustomerID', headerText: 'Customer Name', width: 120},
        { field: 'Freight', headerText: 'Freight', width: 120, format: 'C2', textAlign: 'Right', editType: 'numericedit', validationRules: { required: true, min: 1, max: 1000 }},
        { field: 'OrderDate', headerText: 'Order Date', width: 130, editType: 'datepickeredit', format: 'yMd', textAlign: 'Right'},
        { field: 'ShipCountry', headerText: 'Ship Country', width: 300,
         edit: {
            create: function(){
                dropdownlistElem = document.createElement('input');
                return dropdownlistElem;
            },
            read: function() {
                return dropdownlistObj.value;
            },
            destroy: function() {
                dropdownlistObj.destroy();
            },
            write: function(args){
                var rowData = args.rowData;
                dropdownlistObj = new ej.dropdowns.DropDownList({
                    dataSource: data,
                    query: new ej.data.Query().from('data').select(['EmployeeID', 'ShipCountry', 'OrderID']).take(6),
                    fields:  { text: 'ShipCountry' },
                    value: rowData.ShipCountry,
                    change: function(args) {
                        // Update the EmployeeID value in the rowData 
                        rowData.ShipCountry = args.value;
                    },
                    headerTemplate: '<table><tr><th>EmployeeID</th><th>ShipCountry</th></tr></table>',
                    itemTemplate: '<div class="e-grid"><table class="e-table"><tbody><tr><td class="e-rowcell">${EmployeeID}</td><td class="e-rowcell">${ShipCountry}</td></tr></tbody></table></div>'
                });
                dropdownlistObj.appendTo(args.element);
            }
        } }
    ],
    height: 273
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<style>
    .content {
        margin: 0 auto;
        width: 550px;
    }
    table{
        width:100%;
        border-collapse: separate;
        table-layout: fixed; 
    }
    th,td{  
        border-width: 1px 0 0 1px;
        border-color: #e0e0e0;
        text-align: left;
        border-style: solid;
        display: table-cell; 
    }
    th{
        line-height: 36px;
        text-indent: 16px;
    }
    .e-ddl-header{
        padding-right: 17px;
        border-width: 1px 0px 1px 0px;
        border-color: #e0e0e0;
        border-style: solid;
    }
    .e-dropdownbase .e-list-item{
        padding-right:0px;
    }
</style>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Render ComboBox control in edit form

The Syncfusion® Grid allows you to render a ComboBox control within the Grid’s edit form for a specific column. This feature is especially valuable when you need to provide a drop-down selection with auto-suggestions for data entry.

To render a comboBox control in the edit form, you need to define a cell edit template for the column using edit property. The edit property specifies the cell edit template that used as an editor for a particular column.

The following example demonstrates how to render a ComboBox control in the ShipCountry column of the Syncfusion® Grid.

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);

var comboboxElem;
var comboboxObj;

var grid = new ej.grids.Grid({
    dataSource: data,
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Normal' },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    columns: [
        { field: 'OrderID', headerText: 'Order ID', width: 120, textAlign: 'Right', isPrimaryKey: true, validationRules: { required: true } },
        { field: 'CustomerID', headerText: 'Customer Name', width: 120 },
        { field: 'Freight', headerText: 'Freight', width: 120, format: 'C2', textAlign: 'Right', editType: 'numericedit', validationRules: { required: true, min: 1, max: 1000 } },
        { field: 'OrderDate', headerText: 'Order Date', width: 130, editType: 'datepickeredit', format: 'yMd', textAlign: 'Right' },
        {
            field: 'ShipCountry', headerText: 'Ship Country', width: 150,
            edit: {
                create: function () {
                    comboboxElem = document.createElement('input');
                    return comboboxElem;
                },
                read: function () {
                    return comboboxObj.value;
                },
                destroy: function () {
                    comboboxObj.destroy();
                },
                write: function (args) {
                    var rowData = args.rowData;
                    comboboxObj = new ej.dropdowns.ComboBox({
                        dataSource: selectDatasource,
                        value: rowData.ShipCountry,
                        change: function (e) {
                            rowData.ShipCountry = e.value;
                        }
                    });
                    comboboxObj.appendTo(args.element);
                }
            }
        }
    ],
    height: 273
});
grid.appendTo('#Grid');

var selectDatasource = [
    { text: 'Germany', value: 'Germany' },
    { text: 'Brazil', value: 'Brazil' },
    { text: 'Belgium', value: 'Belgium' },
    { text: 'Switzerland', value: 'Switzerland' },
    { text: 'Venezuela', value: 'Venezuela' },
    { text: 'Austria', value: 'Austria' },
    { text: 'Mexico', value: 'Mexico' },
];
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Render TimePicker control in edit form

The Syncfusion® Grid allows you to render a TimePicker control within the Grid’s edit form for a specific column. This feature is especially valuable when you need to provide a time input, such as appointment times, event schedules, or any other time-related data for editing in the Grid.

To render a TimePicker control in the edit form, you need to define a cell edit template for the column using edit property. The edit property specifies the cell edit template that used as an editor for a particular column.

The following example demonstrates how to render a TimePicker control in the OrderDate column of the Syncfusion® Grid.

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);

var timepickerElem;
var timepickerObj;

var grid = new ej.grids.Grid({
    dataSource: data,
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    columns: [
        { field: 'OrderID', headerText: 'Order ID', width: 120, textAlign: 'Right', isPrimaryKey: true, validationRules: { required: true } },
        { field: 'CustomerID', headerText: 'Customer Name', width: 120 },
        { field: 'Freight', headerText: 'Freight', width: 120, format: 'C2', textAlign: 'Right' },
        { field: 'ShipCountry', headerText: 'Ship Country', width: 150 },
        { field: 'OrderDate', headerText: 'Order Date', width: 140, format: 'yMd', editType: 'DatePickerEdit', textAlign: 'Right' },
        {
            field: 'OrderDate', headerText: 'Order Time', width: 140, format: 'hh :mm a', textAlign: 'Right',
            edit: {
                create: function () {
                    timepickerElem = document.createElement('input');
                    return timepickerElem;
                },
                read: function () {
                    return timepickerObj.value;
                },
                destroy: function () {
                    timepickerObj.destroy();
                },
                write: function (args) {
                    var rowData = args.rowData;
                    timepickerObj = new ej.calendars.TimePicker({
                        value: rowData.OrderDate,
                        change: function (e) {
                            rowData.OrderDate = e.value;
                        }
                    });
                    timepickerObj.appendTo(args.element);
                }
            }
        }
    ],
    height: 273
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Render MultiSelect control in edit form

The Syncfusion® Grid allows you to render a MultiSelect control within the Grid’s edit form, enabling you to select multiple values from a dropdown list when editing a specific column. This feature is particularly useful when you need to handle situations where multiple selections are required for a column.

To render a MultiSelect control in the edit form, you need to define a cell edit template for the column using edit property. The edit property specifies the cell edit template that used as an editor for a particular column.

The following example demonstrates how to render a MultiSelect control in the ShipCity column of the Syncfusion® Grid. The actionBegin event is handled to update the edited value in the grid when the save button is clicked:

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);

var multiselectElem;
var multiselectObj;
var orderData;

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
    dataSource: data,
    editSettings: {  allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    actionBegin: actionBegin,
    columns: [
        { field: 'OrderID', headerText: 'Order ID', width: 120, textAlign: 'Right', isPrimaryKey: true, validationRules: { required: true } },
        { field: 'CustomerID', headerText: 'Customer Name', width: 120},
        { field: 'Freight', headerText: 'Freight', width: 120, format: 'C2', textAlign: 'Right', editType: 'numericedit',validationRules: { required: true, min: 1, max: 1000 }},
        { field: 'OrderDate', headerText: 'Order Date', width: 130, editType: 'datepickeredit', format: 'yMd', textAlign: 'Right'},
        { field: 'ShipCity', headerText: 'Ship City', width: 150, format: 'hh :mm a', textAlign: 'Right',
         edit: {
            create: function(){
                multiselectElem = document.createElement('input');
                return multiselectElem;
            },
            read: function() {
                return multiselectObj.value;
            },
            destroy: function() {
                multiselectObj.destroy();
            },
            write: function(args){
                multiselectObj = new ej.dropdowns.MultiSelect({
                    dataSource: multiselectDatasource,
                    value: orderData.ShipCity,
                    fields: { value: 'value', text: 'text' },
                    change: function(e) {
                        orderData.ShipCity = e.value; // Update orderData.ShipCity on change
                    }
                });
                multiselectObj.appendTo(args.element);
            }
        } }
    ],
    height: 273
});
grid.appendTo('#Grid');

var multiselectDatasource = [
    { value: 'Reims', text: 'Reims' },
    { value: 'Münster', text: 'Münster' },
    { value: 'Rio de Janeiro', text: 'Rio de Janeiro' },
    { value: 'Lyon', text: 'Lyon' },
    { value: 'Charleroi', text: 'Charleroi' }
];

function actionBegin(args) {
    if (args.requestType === 'beginEdit' || args.requestType === 'add') {
        orderData = Object.assign({}, args.rowData);

        orderData['ShipCity'] = orderData['ShipCity'] ? orderData['ShipCity'].split(',') : [];

    }
    if (args.requestType === 'save') {
        args.data['ShipCity'] = orderData['ShipCity'].join(',');
    }
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Render RichTextEditor control in edit form

The Syncfusion® Grid allows you to render the RichTextEditor control within the edit form. This feature is valuable when you need to format and style text content using various formatting options such as bold, italic, underline, bullet lists, numbered lists, and more during editing a specific column.

To render RichTextEditor control in edit form,you need to define a cell edit template for the column using edit property. The edit property specifies the cell edit template that used as an editor for a particular column.

Additionally, you need set the allowTextWrap property of the corresponding grid column to true. By enabling this property, the rich text editor control will automatically adjust its width and wrap the text content to fit within the boundaries of the column.

The following example demonstrates how to render a RichTextEditor control in the ShipAddress column of the Syncfusion® Grid.

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar, ej.grids.Page);

var richtexteditorElem;
var richtexteditorObj;

var grid = new ej.grids.Grid({
    dataSource: data,
    allowPaging: true,
    allowTextWrap: true,
    pageSettings: {  pageSize: 7 },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
    created: created,
    columns: [
    { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', width: 100, isPrimaryKey: true, validationRules: { required: true } },
    { field: 'CustomerID', headerText: 'Customer ID', validationRules: { required: true }, width: 100 },
    { field: 'Freight', headerText: 'Freight', width: 100, format: 'C2', textAlign: 'Right', editType: 'numericedit', validationRules: { required: true } },
    { field: 'OrderDate', headerText: 'Order Date', width: 100, editType: 'datepickeredit', format: { type: 'dateTime', format: 'M/d/y hh:mm a' }, textAlign: 'Right'},
    {
        field: 'ShipAddress', headerText: 'Ship Address', width: 150, edittype: 'textarea', disableHtmlEncode: false, edit: {
        create: function () {
            richtexteditorElem = document.createElement('textarea');
            return richtexteditorElem;
        },
        destroy: function () {
            richtexteditorObj.destroy();
        },
        read: function () {
            return richtexteditorObj.value;
        },
        write: function (args) {
            var rowData = args.rowData
            richtexteditorObj = new ej.richtexteditor.RichTextEditor({
            value: rowData.ShipAddress,
            focus: onFocus,
            change: function (e) {
                rowData.ShipAddress = e.value;
            }
            });
            richtexteditorObj.appendTo(richtexteditorElem);
        }
        }
    }
    ],
    pageSettings: { pageSize: 7 },
    height: 255,
});
grid.appendTo('#Grid');


function onFocus(args)
{
    ((args.event).target).addEventListener('keydown', (e) => {
        if (e.key === 'Enter') {
            e.stopPropagation();
        }
    });
}

function created() {
    this.keyConfigs.enter = '';
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Render Upload control in edit form

The Syncfusion® Grid allows you to render an Upload control within the Grid’s edit form. This feature is especially valuable when you need to upload and manage files or images in a specific column during data editing.

To render Upload control in edit form, you need to define a cell edit template for the column using edit property. The edit property specifies the cell edit template that used as an editor for a particular column.

The following example demonstrates how to render a Upload control in the Employee Image column of the Syncfusion® Grid. The actionBegin event is handled to update the edited value in the grid when the save button is clicked:

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar, ej.grids.Page);

var uploaderElem;
var uploaderObj;
var strm;

var grid = new ej.grids.Grid({
    dataSource: employeeData,
    allowPaging: true,
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    columns: [
        { field: 'EmployeeID', headerText: 'Employee ID', textAlign: 'Right', isPrimaryKey: true, width: 100 },
        { field: 'FirstName', headerText: 'First Name', textAlign: 'Left', width: 120 },
        { field: 'LastName', headerText: 'Last Name', textAlign: 'Left', width: 120 },
        { field: 'Title', headerText: 'Title', textAlign: 'Left', width: 120 },
        {
            headerText: 'Employee Image', width: 150, textAlign: 'Center', template: function (props) {
                var src = !props.Image ? 'https://ej2.syncfusion.com/angular/demos/assets/grid/images/' + props.EmployeeID + '.png' : props.Image;
                return '<div class="image"><img src="' + src + '" alt="' + props.EmployeeID + '" /></div>';
            },
            edit: {
                create: function () {
                    uploaderElem = document.createElement('input');
                    return uploaderElem;
                },
                destroy: function () {
                    uploaderObj.destroy();
                },
                read: function () {
                    return uploaderObj.value;
                },
                write: function (args) {
                    uploaderObj = new ej.inputs.Uploader({
                        asyncSettings: {
                            saveUrl: 'https://services.syncfusion.com/react/production/api/FileUploader/Save',
                            removeUrl: 'https://services.syncfusion.com/react/production/api/FileUploader/Remove'
                        },
                        multiple: false,
                        success: function onUploadSuccess() {
                            if (args.operation === 'upload') {
                                var fileBlob = args.file.rawFile;
                                var file = new File([fileBlob], args.file.name);
                                getBase64(file, function (result) {
                                    args.rowData['Image'] = result;
                                    grid.updateRow(args.rowIndex, args.rowData);
                                });
                            }
                        }
                    });
                    uploaderObj.appendTo(uploaderElem);
                }
            }
        }
    ],
    pageSettings: { pageSize: 7 },
    height: 273
});
grid.appendTo('#Grid');

function getBase64(file, callback) {
    var reader = new FileReader();
    reader.readAsDataURL(file);
    reader.onload = function () {
        callback(reader.result);
    };
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<style>
    .image img {
     height: 55px;
     width: 55px;
     border-radius: 50px;
     box-shadow: inset 0 0 1px #e0e0e0, inset 0 0 14px rgba(0, 0, 0, 0.2);
     }
 </style>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

By default, the grid saves the cell when clicking outside the editor component. If your components, like multiple popups, are dynamically rendered, the grid may not recognize them, causing the editor to close when the popup is clicked. To prevent this, apply the edit-custom-template class to both your main component and sub-components. If you are using Syncfusion® components, set their cssClass property to include the edit-custom-template class.

Render AutoComplete in edit form

The Syncfusion EJ2 JavaScript Grid allows you to render the AutoComplete within the edit form by using the cell edit template feature.This feature enables you to select values from a predefined list during the editing of a specific column. It is especially valuable when you need to provide a dropdown-like auto-suggestion and input assistance for data entry in the Grid’s columns.

To achieve this, you need to define the cell edit template for the column using the edit property. This property specifies the necessary functions for creating, reading, and writing the AutoComplete into the specific column.

The following example demonstrates how to render a Autocomplete in the CustomerID column:

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar, ej.grids.Page);

var autoCompleteElement;
var autoCompleteIns;
var orderData;

var grid = new ej.grids.Grid({
  dataSource: data,
  editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
  toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
  actionBegin: actionBegin,
  columns: [
    { field: 'OrderID', headerText: 'Order ID', width: 120, textAlign: 'Right', isPrimaryKey: true, validationRules: { required: true } },
    {
      field: 'CustomerID', headerText: 'Customer Name', width: 120
      , edit: {
        create: createCustomerIDFn,
        destroy: destroyCustomerIDFn,
        read: readCustomerIDFn,
        write: writeCustomerIDFn
      }
    },
    { field: 'Freight', headerText: 'Freight', width: 120, format: 'C2', textAlign: 'Right', editType: 'numericedit', validationRules: { required: true, min: 1, max: 1000 } },
    { field: 'OrderDate', headerText: 'Order Date', width: 130, editType: 'datepickeredit', format: 'yMd', textAlign: 'Right' },
    { field: 'ShipCountry', headerText: 'Ship Country', width: 150 }
  ],
  height: 273
});
grid.appendTo('#Grid');

var autoCompleteData = [
  { value: 'VINET', text: 'VINET' },
  { value: 'TOMSP', text: 'TOMSP' },
  { value: 'HANAR', text: 'HANAR' },
  { value: 'VICTE', text: 'VICTE' },
  { value: 'SUPRD', text: 'SUPRD' },
];

function createCustomerIDFn() {
  autoCompleteElement = document.createElement('input');
  return autoCompleteElement;
}
function destroyCustomerIDFn() {
  autoCompleteIns.destroy();
}
function readCustomerIDFn() {
  return autoCompleteIns.value;
}
function writeCustomerIDFn() {
  autoCompleteIns = new ej.dropdowns.AutoComplete({
    dataSource: autoCompleteData,
    value: orderData.CustomerID,
    change: function (args) {
      orderData.CustomerID = args.value;
    }
  });
  autoCompleteIns.appendTo(autoCompleteElement);
}

function actionBegin(args) {
  if (args.requestType === 'beginEdit' || args.requestType === 'add') {
    orderData = Object.assign({}, args.rowData);
  }
  if (args.requestType === 'save') {
    (args.data)['CustomerID'] = orderData['CustomerID'];
  }
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Render cascading DropDownList in edit form

The Syncfusion EJ2 JavaScript Grid allows you to render the cascading DropDownList within the edit form by using the cell edit template feature.This feature is especially useful when you need to establish a hierarchy of options, such as choosing a country and then selecting a state based on the chosen country.

To achieve this, you need to define the cell edit template for the column using the edit property. This property specifies the necessary functions for creating, reading, and writing the cascading DropDownList.

In the below demo, cascading DropDownList rendered for ShipCountry and ShipState column.

ej.grids.Grid.Inject(ej.grids.Edit, ej.grids.Toolbar, ej.grids.Page);

var countryElement;
var countryObj;
var stateElement;
var stateObj;

var grid = new ej.grids.Grid({
    dataSource: data,
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    columns: [
        { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', isPrimaryKey: true, width: 100 },
        { field: 'CustomerID', headerText: 'Customer ID', width: 120 },
        {
            field: 'ShipCountry', headerText: 'Ship Country', editType: 'dropdownedit',
            edit:
            {
                create: function () {
                    countryElement = document.createElement('input');
                    return countryElement;
                },
                destroy: function () {
                    countryObj.destroy();
                },
                read: function () {
                    return countryObj.text;
                },
                write: function () {
                    countryObj = new ej.dropdowns.DropDownList({
                        dataSource: new ej.data.DataManager(country),
                        fields: { value: 'countryId', text: 'countryName' },
                        change: () => {
                            stateObj.enabled = true;
                            var tempQuery = new ej.data.Query().where('countryId', 'equal', countryObj.value);
                            stateObj.query = tempQuery;
                            stateObj.text = '';
                            stateObj.dataBind();
                        },
                        placeholder: 'Select a country',
                        floatLabelType: 'Never'
                    });
                    countryObj.appendTo(countryElement);
                }
            },
            width: 150
        },
        {
            field: 'ShipState', headerText: 'Ship State', editType: 'dropdownedit',
            edit:
            {
                create: function () {
                    stateElement = document.createElement('input');
                    return stateElement;
                },
                destroy: function () {
                    stateObj.destroy();
                },
                read: function () {
                    return stateObj.text;
                },
                write: function () {
                    stateObj = new ej.dropdowns.DropDownList({
                        dataSource: new ej.data.DataManager(state),
                        fields: { value: 'stateId', text: 'stateName' },
                        enabled: false,
                        placeholder: 'Select a state',
                        floatLabelType: 'Never'
                    });
                    stateObj.appendTo(stateElement);
                }
            },
            width: 120
        },
        { field: 'OrderDate', headerText: 'OrderDate', type: 'date', format: 'yMd', editType: 'datepickeredit', width: 150 }
    ],
    pageSettings: { pageSize: 7 },
    height: 273
});
grid.appendTo('#Grid');

var state = [
    { stateName: 'New York', countryId: '1', stateId: '101' },
    { stateName: 'Virginia ', countryId: '1', stateId: '102' },
    { stateName: 'Washington', countryId: '1', stateId: '103' },
    { stateName: 'Queensland', countryId: '2', stateId: '104' },
    { stateName: 'Tasmania ', countryId: '2', stateId: '105' },
    { stateName: 'Victoria', countryId: '2', stateId: '106' }
];

var country = [
    { countryName: 'United States', countryId: '1' },
    { countryName: 'Australia', countryId: '2' }
];
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/material3.css" rel="stylesheet" />
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Edit Types and Custom Editors in Angular Data Grid
05 Sep 202624 minutes to read
The Data Grid supports built-in edit types and custom editors for editing data within grid cells. It provides editor interfaces for different data types and supports custom editing experiences to meet specific application requirements.
Built-in cell editors
The Data Grid includes built-in cell editors that provide an appropriate editing interface based on the column data type. For example, a date column can use a DatePicker editor, while a numeric column can use a NumericTextBox editor. This helps ensure that data is entered in a format that matches the column’s data type.
Cell editors can be enabled by setting the editType property in the grid column definition. Supported editors include TextBox, NumericTextBox, DatePicker, DateTimePicker, CheckBox, and DropDownList editors, enabling data entry and validation that align with the column’s requirements. The available default edit types are as follows:
| Component | Edit Type value | Description |
|---|---|---|
| TextBox | stringedit |
Renders a TextBox component for string data type columns. |
| NumericTextBox | numericedit |
Renders a NumericTextBox component for integers, double, float, short, byte, long, long double, and decimal data types. |
| DropDownList | dropdownedit |
Renders a DropDownList component for string data type columns with predefined options. |
| CheckBox | booleanedit |
Renders a CheckBox component for boolean data type columns. |
| DatePicker | datepickeredit |
Renders a DatePicker component for date data type columns. |
| DateTimePicker | datetimepickeredit |
Renders a DateTimePicker component for date-time data type columns. |
The following example demonstrates defining the editType for grid columns:
<e-column field="CustomerName" headerText="Customer Name" editType="stringedit"></e-column>
<e-column field="Freight" headerText="Freight" editType="numericedit"></e-column>
<e-column field="ShipCountry" headerText="Ship Country" editType="dropdownedit"></e-column>
<e-column field="OrderDate" headerText="Order Date" editType="datepickeredit"></e-column>
<e-column field="OrderTime" headerText="Order Time" editType="datetimepickeredit"></e-column>
<e-column field="Verified" headerText="Verified" editType="booleanedit"></e-column>When the edit type is not defined for a column, the Data Grid defaults to the
stringeditedit type and displays aTextBoxeditor for editing values.
Customize built-in TextBox editor
The TextBox editor can be customized by configuring its component properties through the columns.edit.params option. This allows TextBox features, behavior, and appearance to be customized during editing.
| Component | Edit Type | Description | Example Customized edit params |
|---|---|---|---|
| TextBox | stringedit | The stringedit type renders a TextBox component for string data type columns. To customize the TextBox component, refer to the TextBox API documentation for detailed information on available properties |
params: { showClearButton : true} |
The following sample code demonstrates the customization applied to TextBox component of “Customer ID” grid column:
import { data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, DropDownListModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, IEditCell, PageService, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule,
DropDownListModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='265px'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' textAlign='Right'
isPrimaryKey='true' width=100></e-column>
<e-column field='CustomerID' [edit]='stringParams' headerText='Customer ID' width=120></e-column>
<e-column field='Freight' headerText='Freight' textAlign= 'Right'
editType= 'numericedit' width=120></e-column>
<e-column field='ShipCity' headerText='Ship City' editType= 'dropdownedit' width=150>
</e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public stringParams?: IEditCell;
ngOnInit(): void {
this.data = data;
this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
this.stringParams = {
params: {
showClearButton: true
}
};
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Customize built-in NumericTextBox editor
The NumericTextBox editor can be customized by configuring its component properties through the grid columns.edit.params property. This allows NumericTextBox features, behavior, and appearance to be customized during editing
| Component | Edit Type | Description | Example Customized edit params |
|---|---|---|---|
| NumericTextBox | numericedit | The numericedit type renders a NumericTextBox component for integer, double, float, short, byte, long, long double, and decimal data type columns. To customize the NumericTextBox component, refer to the NumericTextBox API documentation for detailed information on available properties. |
params: { decimals: 2, value: 5 } |
The following sample code demonstrates the customization applied to NumericTextBox component of “Freight” grid column:
import { data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, IEditCell, PageService, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='265px'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' textAlign='Right' [validationRules]='orderIDRules'
isPrimaryKey='true' width=100></e-column>
<e-column field='CustomerID' [validationRules]='customerIDRules' headerText='Customer ID' width=120></e-column>
<e-column field='Freight' headerText='Freight' textAlign= 'Right'
editType= 'numericedit' [edit] ='numericParams' [validationRules]='freightRules' width=120></e-column>
<e-column field='ShipCity' headerText='Ship City' editType= 'dropdownedit' [validationRules]='shipCityRules' width=150>
</e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public numericParams?: IEditCell;
public orderIDRules?: Object;
public customerIDRules?: Object;
public freightRules?: Object;
public shipCityRules?: Object;
ngOnInit(): void {
this.data = data;
this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
this.orderIDRules = { required: true, number: true };
this.customerIDRules = { required: true };
this.freightRules = { required: true, min: 1, max: 1000 };
this.shipCityRules = { required: true };
this.numericParams = {
params: {
decimals: 0,
format: 'N',
showClearButton: true,
showSpinButton: false
}
};
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Restrict decimal input in NumericTextBox while editing
NumericTextBox allows decimal input by default. To restrict entries to whole numbers, use the validateDecimalOnType (set to true to block decimals) and decimals properties.
In this demo, while editing a row, decimal values are restricted when typing into the NumericTextBox of the “Freight” column.
import { data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule } from '@syncfusion/ej2-angular-calendars';
import { EditService, EditSettingsModel, GridModule, IEditCell, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
@Component({
imports: [ GridModule, DatePickerAllModule, FormsModule ],
providers: [EditService, ToolbarService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='265px'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' textAlign='Right' isPrimaryKey='true' width=100></e-column>
<e-column field='CustomerID' headerText='Customer ID' width=120></e-column>
<e-column field='Freight' headerText='Freight' textAlign= 'Right'
editType= 'numericedit' [edit]='numericParams' width=120></e-column>
<e-column field='ShipCity' headerText='Ship City' editType= 'dropdownedit' width=150>
</e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public numericParams?: IEditCell;
ngOnInit(): void {
this.data = data;
this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
this.numericParams = { params: {
validateDecimalOnType: true,
decimals: 0,
format: 'N' }
};
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Customize built-in DropDownList editor
Customize the DropDownList editor via columns->edit->params. This allows configuration of DropDownList properties for string columns.
| Component | Edit Type | Description | Example edit params |
|---|---|---|---|
| DropDownList | dropdownedit | The dropdownedit type renders a DropDownList component for string data type columns. To customize the DropDownList component, refer to the DropDownList API documentation for detailed information on available properties. |
params: { value: ‘Germany’ } |
The following sample code demonstrates the customization applied to DropDownList component of “Ship City” grid column:
import { data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, IEditCell, PageService, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='265px'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' textAlign='Right' isPrimaryKey='true' [validationRules]='orderIDRules' width=100></e-column>
<e-column field='CustomerID' headerText='Customer ID' [validationRules]='customerIDRules' width=120></e-column>
<e-column field='Freight' headerText='Freight' textAlign= 'Right'
editType= 'numericedit' width=120 [validationRules]='freightRules'></e-column>
<e-column field='ShipCity' headerText='Ship City' editType='dropdownedit' [edit]='dropdownparams' [validationRules]='shipCityRules' width=150>
</e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public dropdownparams?: IEditCell;
public orderIDRules?: Object;
public customerIDRules?: Object;
public freightRules?: Object;
public shipCityRules?: Object;
ngOnInit(): void {
this.data = data;
this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
this.orderIDRules = { required: true, number: true };
this.customerIDRules = { required: true };
this.freightRules = { required: true, min: 1, max: 1000 };
this.shipCityRules = { required: true };
this.dropdownparams = {
params: {
showClearButton: true,
popupHeight: 120
}
};
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Bind external data to DropDownList
In Syncfusion’s Data Grid component, there is an option to provide a custom data source for the DropDownList component in the edit form. This feature allows defining a specific set of values for the DropDownList.
To achieve this, the columns->edit->params property can be utilized. This property allows defining the edit params for the column within the grid.
When setting a new data source using the edit params, a new query property must be specified for the DropDownList. The query property enables defining custom queries for data retrieval and filtering.
In this demo, the DropDownList is rendered with a custom data source for the “Ship Country” column:
import { cascadeData } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, DropDownListModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, IEditCell, PageService, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
import { DataManager, Query } from '@syncfusion/ej2-data';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule,
DropDownListModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='273px'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' [validationRules]='orderIDRules' textAlign='Right' isPrimaryKey='true' width=100></e-column>
<e-column field='CustomerID' [validationRules]='customerIDRules' headerText='Customer ID' width=120></e-column>
<e-column field='ShipCountry' headerText='Ship Country' editType= 'dropdownedit' [validationRules]='shipCountryRules'
[edit]='countryParams' width=150></e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public countryParams?: IEditCell;
public orderIDRules?: Object;
public customerIDRules?: Object;
public shipCountryRules?: Object;
public country: object[] = [
{ countryName: 'United States', countryId: '1' },
{ countryName: 'Australia', countryId: '2' },
{ countryName: 'India', countryId: '3' }
];
ngOnInit(): void {
this.data = cascadeData;
this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
this.orderIDRules = { required: true, number: true };
this.customerIDRules = { required: true };
this.shipCountryRules = { required: true };
this.countryParams = {
params: {
dataSource: new DataManager(this.country),
fields: { text: 'countryName', value: 'countryName' },
query: new Query(),
actionComplete: () => false
}
};
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));DropDownList editor with filter support
The Data Grid component provides filtering for the DropDownList within the edit form. This feature enables selection of options from a predefined list and easier search for specific items using the built-in filtering feature.
Enable filtering by setting the allowFiltering property to true within the edit params. This enables the filtering feature in the DropDownList.
In the following demo, filtering is enabled for the “Ship Country” column:
import { cascadeData } from './datasource';
import { Component, NgModule, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { BrowserModule } from '@angular/platform-browser';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, DropDownListModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, IEditCell, PageService, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule,
DropDownListModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='273px'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' [validationRules]='orderIDRules' textAlign='Right' isPrimaryKey='true' width=100></e-column>
<e-column field='CustomerID' [validationRules]='customerIDRules' headerText='Customer ID' width=120></e-column>
<e-column field='ShipCountry' headerText='Ship Country' editType= 'dropdownedit' [validationRules]='shipCountryRules'
[edit]='countryParams' width=150></e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public countryParams?: IEditCell;
public orderIDRules?: Object;
public customerIDRules?: Object;
public shipCountryRules?: Object;
ngOnInit(): void {
this.data = cascadeData;
this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
this.orderIDRules = { required: true, number: true };
this.customerIDRules = { required: true };
this.shipCountryRules = { required: true };
this.countryParams = {
params: {
allowFiltering: true,
}
};
}
}import { AppComponent } from './app.component';
import { bootstrapApplication } from '@angular/platform-browser';
bootstrapApplication(AppComponent).catch((err) => console.error(err));DropDownList popup on focus
Open the dropdown edit popup with a single click by focusing the dropdown element. This feature enables quick access and interaction with the dropdown options without the need for an additional click.
To achieve this, utilize the showPopup method provided by the EJ2 DropDownList component. This method can be invoked within the actionComplete event of the grid, which triggers when an action, such as editing, is completed. By calling the showPopup method in this event, open the popup for the dropdown edit.
To ensure that the dropdown column is the clicked edit target, set a global flag variable in the mouseup event along with load event. This flag variable determines if the clicked element corresponds to the dropdown column.
The following sample demonstrates how to open the popup when focusing on the edit cell using the actionComplete and load events:
import { data } from './datasource';
import { Component, OnInit, ViewChild } from '@angular/core';
import { Column, EditEventArgs, EditService, EditSettingsModel, GridComponent, GridModule, PageService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
@Component({
imports: [ GridModule ],
providers: [EditService, PageService, ToolbarService],
standalone: true,
selector: 'app-root',
template: `
<ejs-grid #grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' allowPaging='true' (load)='load($event)' (actionComplete)='onActionComplete($event)' height='220px'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' textAlign='Right' width=100 isPrimaryKey='true'></e-column>
<e-column field='CustomerID' headerText='Customer ID' width=120></e-column>
<e-column field='Freight' headerText='Freight' textAlign='Right' width=120 format='C2'></e-column>
<e-column field='ShipCountry' headerText='Ship Country' editType='dropdownedit' width=150></e-column>
</e-columns>
</ejs-grid>
`
})
export class AppComponent implements OnInit {
public data?: object[];
public toolbar?: ToolbarItems[];
@ViewChild('grid')
public grid?: GridComponent;
public editSettings?: EditSettingsModel;
public isDropdown = false;
ngOnInit(): void {
this.data = data;
this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Normal' };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
}
load(args: Object) {
(this.grid as GridComponent).element.addEventListener('mouseup', (e: MouseEvent) => {
if ((e.target as HTMLElement).classList.contains('e-rowcell')) {
if ((this.grid as GridComponent).isEdit) {
(this.grid as GridComponent).endEdit();
}
let rowInfo = (this.grid as GridComponent).getRowInfo(e.target as EventTarget);
if (rowInfo && rowInfo.column && (rowInfo.column as Column).field === 'ShipCountry') {
this.isDropdown = true;
(this.grid as GridComponent).selectRow((rowInfo.rowIndex as number));
(this.grid as GridComponent).startEdit();
}
}
});
}
onActionComplete(args: EditEventArgs) {
if (args.requestType === 'beginEdit' && this.isDropdown) {
this.isDropdown = false;
let dropdownObj = ((args.form as HTMLFormElement).querySelector('.e-dropdownlist') as HTMLFormElement)['ej2_instances'][0] ;
dropdownObj.element.focus();
dropdownObj.showPopup();
}
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Customize built-in CheckBox editor
Customize the CheckBox component using the columns->edit->params property.
| Component | Edit Type | Description | Example edit params |
|---|---|---|---|
| CheckBox | booleanedit | The booleanedit type renders a CheckBox component for boolean data type. To customize the CheckBox component, refer to the CheckBox API documentation for detailed information on available properties. |
params: { checked: true } |
The following sample code demonstrates the customization applied to CheckBox component of “Verified” grid column:
import { data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, IEditCell, PageService, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='265px'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' textAlign='Right' isPrimaryKey='true' [validationRules]='orderIDRules' width=100></e-column>
<e-column field='CustomerID' headerText='Customer ID' width=120 [validationRules]='customerIDRules' ></e-column>
<e-column field='Freight' headerText='Freight' [validationRules]='freightRules' textAlign= 'Right'
editType= 'numericedit' width=120></e-column>
<e-column field='ShipCity' headerText='Ship City' editType= 'dropdownedit' [validationRules]='shipCityRules' width=150>
</e-column>
<e-column field="OrderDate" headerText="Order Date" width="100" format='yyyy-MM-dd' editType= 'datetimepickeredit' [validationRules]='orderDateRules' ></e-column>
<e-column field='Verified' headerText='Verified' width='100' [displayAsCheckBox]='true'
editType= 'booleanedit' [edit]='booleanparams' ></e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public booleanparams?: IEditCell;
public orderIDRules?: Object;
public customerIDRules?: Object;
public freightRules?: Object;
public shipCityRules?: Object;
public orderDateRules?: Object;
ngOnInit(): void {
this.data = data;
this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
this.orderIDRules = { required: true, number: true };
this.customerIDRules = { required: true };
this.freightRules = { required: true, min: 1, max: 1000 };
this.shipCityRules = { required: true };
this.orderDateRules = { required: true };
this.booleanparams = {
params: {
disabled: true,
}
};
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Customize built-in DatePicker editor
Enhance the DatePicker component in grid edit form by customizing its properties. This enables configuration of various DatePicker features, tailoring its behavior and appearance to match specific requirements within the grid. Fine-tune the editor component behavior through the columns->edit->params property for date selection behavior.
| Component | Edit Type | Description | Example edit params |
|---|---|---|---|
| DatePicker | datepickeredit | The datepickeredit type renders a DatePicker component for date data type columns. To customize the DatePicker component, refer to the DatePicker API documentation for detailed information on available properties. |
params: { format:’dd.MM.yyyy’ } |
The following sample code demonstrates the customization applied to DatePicker component of “Order Date” grid column:
import { data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, IEditCell, PageService, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='265px'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' textAlign='Right' [validationRules]='orderIDRules' isPrimaryKey='true' width=100></e-column>
<e-column field='CustomerID' headerText='Customer ID' width=120 [validationRules]='customerIDRules'></e-column>
<e-column field='Freight' headerText='Freight' [validationRules]='freightRules' textAlign= 'Right'
editType= 'numericedit' width=120></e-column>
<e-column field='ShipCity' headerText='Ship City' editType= 'dropdownedit' [validationRules]='shipCityRules' width=150>
</e-column>
<e-column field="OrderDate" headerText="Order Date" width="150" format='MM-dd-yyyy'
editType= 'datepickeredit' [edit]='datepickerparams' [validationRules]='orderDateRules' ></e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public datepickerparams?: IEditCell;
public orderIDRules?: Object;
public customerIDRules?: Object;
public freightRules?: Object;
public shipCityRules?: Object;
public orderDateRules?: Object;
ngOnInit(): void {
this.data = data;
this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
this.orderIDRules = { required: true, number: true };
this.customerIDRules = { required: true };
this.freightRules = { required: true, min: 1, max: 1000 };
this.shipCityRules = { required: true };
this.orderDateRules = { required: true };
this.datepickerparams = {
params: {
showClearButton: false,
showTodayButton: false
}
};
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Restrict minimum selectable date in DatePicker
Set a minimum selectable date dynamically in the DatePicker editor by configuring the minimum property in edit params. This prevents selection of dates prior to a specified value.
Example with dynamic min date:
import { data } from './datasource';
import { Component, OnInit, ViewChild } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, DropDownListModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridComponent, GridModule, PageService, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule,
DropDownListModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `
<ejs-grid #grid [dataSource]="data" [editSettings]="editSettings" [toolbar]="toolbar" height="250px" (actionBegin)='actionBegin($event)'>
<e-columns>
<e-column field="OrderID" headerText="Order ID" isPrimaryKey="true" textAlign="Right" width="120" [validationRules]='orderIDRules'></e-column>
<e-column field="CustomerID" headerText="Customer Name" width="120" [validationRules]='customerIDRules'></e-column>
<e-column field="OrderDate" headerText="Order Date" editType="datepickeredit" format="M/d/yy" textAlign="Right" [validationRules]='dateRules' width="130" type="date"></e-column>
<e-column field="Freight" headerText="Freight" format="C2" textAlign="Right" width="90" [validationRules]='freightRules'></e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
@ViewChild('grid') public grid?: GridComponent;
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public orderData?: object|any;
public orderIDRules?: object;
public customerIDRules?: object;
public freightRules?: object;
public dateRules?: object;
public verifiedRules?: object;
ngOnInit(): void {
this.data = data;
this.orderIDRules = { required: true };
this.customerIDRules = { required: true };
this.dateRules= { required: true };
this.verifiedRules= { required: true };
this.freightRules = { required: true, min: 1, max: 1000 };
this.editSettings = {
allowEditing: true,
allowAdding: true,
allowDeleting: true,
};
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
}
actionBegin(args: any): void {
if (args.requestType === 'beginEdit') {
let minDate = (args as any).rowData['OrderDate'];
(this.grid as GridComponent).columns.forEach((column) => {
if ((column as any).field === 'OrderDate') {
(column as any).edit.params = { min: minDate };
}
});
}
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Customize built-in DateTimePicker editor
Enhance the DateTimePicker component in grid edit form by customizing its properties. This enables configuration of various DateTimePicker features, tailoring its behavior and appearance to match specific requirements within the grid. Fine-tune the editor component behavior through the columns->edit->params property for date-time selection behavior.
| Component | Edit Type | Description | Example edit params |
|---|---|---|---|
| DateTimePicker | datetimepickeredit | The datetimepickeredit type renders a DateTimePicker component for date time data type columns. Customize the DateTimePicker component by referring to the DateTimePicker API documentation for detailed information on available properties. |
params: { value: new Date() } |
The following sample code demonstrates the customization applied to DateTimePicker component of “Order Date” grid column:
import { data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, DropDownListModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, IEditCell, PageService, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule,
DropDownListModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='265px'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' textAlign='Right' [validationRules]='orderIDRules' isPrimaryKey='true' width=100></e-column>
<e-column field='CustomerID' headerText='Customer ID' width=120 [validationRules]='customerIDRules'></e-column>
<e-column field='Freight' headerText='Freight' textAlign= 'Right'
editType= 'numericedit' width=120 [validationRules]='freightRules'></e-column>
<e-column field='ShipCity' headerText='Ship City' editType= 'dropdownedit' [validationRules]='shipCityRules' width=150>
</e-column>
<e-column field="OrderDate" headerText="Order Date" width="150"
format='MM-dd-yyyy hh mm aa' editType= 'datetimepickeredit' [validationRules]='orderDateRules' [edit]='datetimepickerparams' ></e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public datetimepickerparams?: IEditCell;
public orderIDRules?: Object;
public customerIDRules?: Object;
public freightRules?: Object;
public shipCityRules?:Object;
public orderDateRules?: Object;
ngOnInit(): void {
this.data = data;
this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
this.orderIDRules = { required: true, number: true };
this.customerIDRules = { required: true };
this.freightRules = { required: true,min:1, max:1000 };
this.shipCityRules = { required: true };
this.orderDateRules = { required: true };
this.datetimepickerparams = { params: {
showClearButton : false,
format:'MM-dd-yyyy hh:mm aa',
start:'Year',
}
};
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Render custom editor components
Render custom editors for grid columns using the editTemplate property, and for advanced scenarios, by using custom create, write, read, and destroy methods in the edit property.
For custom components in
editTemplate, use two-way binding (@bind-Value) to ensure updates propagate to the Grid.
Render TextArea in the edit form
The Data Grid allows rendering a TextArea within the Grid’s edit form for a specific column. This feature is especially valuable when there is a need to edit and display multi-line text content, providing an efficient way to manage extensive text data within the Grid’s columns.
To render a TextArea in the edit form, it is necessary to define an editTemplate for the column using ng-template. The editTemplate property specifies the cell edit template that is used as an editor for a particular column. It can accept either a template string or an HTML element ID.
When using a text area, please use Shift+Enter to move to the next line. By default, pressing Enter will trigger a record update while in edit mode.
The following example demonstrates how to render a TextArea component in the “Ship Address” column of the grid. The valueAccessor property is utilized to split the text into multiple lines within the grid column:
import { columnDataType, data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, DropDownListModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, PageService, SaveEventArgs, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule,
DropDownListModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='273px'
(actionBegin)='actionBegin($event)'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey='true' [validationRules]='orderIDRules'></e-column>
<e-column field='CustomerID' headerText='Customer Name' width='120' [validationRules]='customerIDRules'></e-column>
<e-column field='Freight' headerText='Freight' width='120' format='C2' textAlign='Right' editType='numericedit' [validationRules]='freightRules'></e-column>
<e-column field='OrderDate' headerText='Order Date' width='130' editType='datepickeredit' format='yMd' textAlign='Right'></e-column>
<e-column field='ShipAddress' headerText='Ship Address' [valueAccessor]="valueAccessor" [disableHtmlEncode]=false width=150>
<ng-template #editTemplate let-data>
<ejs-textbox id="ShipAddress" [multiline]='true'
[(ngModel)]="orderData.ShipAddress" ></ejs-textbox>
</ng-template>
</e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public orderData?: object | any;
public orderIDRules?: object;
public customerIDRules?: object;
public freightRules?: object;
public valueAccessor = (field: string, data:columnDataType) => {
const value = data.ShipAddress;
return (value !== undefined) ? value.split('\n').join('<br>') : '';
};
ngOnInit(): void {
this.data = data;
this.orderIDRules = { required: true };
this.customerIDRules = { required: true, minLength: 5 };
this.freightRules = { required: true, min: 1, max: 1000 },
this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Normal' };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
}
actionBegin(args: SaveEventArgs) {
if (args.requestType === 'beginEdit' || args.requestType === 'add') {
this.orderData = Object.assign({}, args.rowData);
}
if (args.requestType === 'save') {
(args.data as columnDataType)['ShipAddress'] = this.orderData['ShipAddress'];
}
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Prevent Enter key from saving edits in a multiline textbox
Override the default Enter key behavior in multiline textboxes by using the stopPropagation method in the textbox’s focus event, ensuring Enter inserts a new line instead of saving the edit.
import { columnDataType, data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, DropDownListModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, PageService, SaveEventArgs, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
import { FocusInEventArgs } from '@syncfusion/ej2-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule,
DropDownListModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='273px'
(actionBegin)='actionBegin($event)'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right'
isPrimaryKey='true' [validationRules]='orderIDRules'></e-column>
<e-column field='CustomerID' headerText='Customer Name' width='120'
[validationRules]='customerIDRules'></e-column>
<e-column field='Freight' headerText='Freight' width='120' format='C2' textAlign='Right'
editType='numericedit' [validationRules]='freightRules'></e-column>
<e-column field='OrderDate' headerText='Order Date' width='130' editType='datepickeredit'
format='yMd' textAlign='Right'></e-column>
<e-column field='ShipAddress' headerText='Ship Country' [valueAccessor]="valueAccessor"
[disableHtmlEncode]=false width=150>
<ng-template #editTemplate let-data>
<ejs-textbox id="ShipAddress" [multiline]='true' (focus)="onFocus($event)"
[(ngModel)]="orderData.ShipAddress" ></ejs-textbox>
</ng-template>
</e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public orderData?: object | any;
public orderIDRules?: object;
public customerIDRules?: object;
public freightRules?: object;
public valueAccessor = (field: string, data:columnDataType) => {
const value = data.ShipAddress;
return (value !== undefined) ? value.split('\n').join('<br>') : '';
};
ngOnInit(): void {
this.data = data;
this.orderIDRules = { required: true };
this.customerIDRules = { required: true, minLength: 5 };
this.freightRules = { required: true, min: 1, max: 1000 },
this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Normal' };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
}
actionBegin(args: SaveEventArgs) {
if (args.requestType === 'beginEdit' || args.requestType === 'add') {
this.orderData = Object.assign({}, args.rowData);
}
if (args.requestType === 'save') {
(args.data as columnDataType)['ShipAddress'] = this.orderData['ShipAddress'];
}
}
onFocus(args: FocusInEventArgs): void {
((args.event as Event).target as EventTarget).addEventListener('keydown', (e) => {
if ((e as KeyboardEvent).key === 'Enter') {
e.stopPropagation();
}
});
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Render AutoComplete in the edit form
The Data Grid allows rendering an AutoComplete component within the grid’s edit form for a specific column. This feature is especially valuable when there is a need to provide a dropdown like auto suggestion and input assistance for data entry in the grid’s columns.
To render an AutoComplete component in the edit form, it is necessary to define an editTemplate for the column using ng-template. The editTemplate property specifies the cell edit template that used as an editor for a particular column. It can accept either a template string or an HTML element ID.
The following example demonstrates how to render an AutoComplete component in the “Customer ID” column of the Syncfusion Grid. The actionBegin event is handled to update the edited value in the grid when the save button is clicked:
import { columnDataType, data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, DropDownListModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, PageService, SaveEventArgs, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [ GridModule, DatePickerAllModule, FormsModule, TimePickerModule, FormsModule,TextBoxModule, MultiSelectModule, AutoCompleteModule, DropDownListModule ],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='273px'
(actionBegin)='actionBegin($event)'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right'
isPrimaryKey='true' [validationRules]='orderIDRules'></e-column>
<e-column field='CustomerID' headerText='Customer Name' width='120'>
<ng-template #editTemplate let-data>
<ejs-autocomplete [dataSource]='autoCompleteData' [(value)]='orderData.CustomerID'></ejs-autocomplete>
</ng-template>
</e-column>
<e-column field='Freight' headerText='Freight' width='120' format='C2' textAlign='Right'
editType='numericedit' [validationRules]='freightRules'></e-column>
<e-column field='OrderDate' headerText='Order Date' width='130' editType='datepickeredit'
format='yMd' textAlign='Right'></e-column>
<e-column field='ShipCountry' headerText='Ship Country' width='150'></e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public orderData?: object | any;
public orderIDRules?: object;
public customerIDRules?: object;
public freightRules?: object;
public autoCompleteData: { [key: string]: Object }[] = [
{ value: 'VINET', text: 'VINET' },
{ value: 'TOMSP', text: 'TOMSP' },
{ value: 'HANAR', text: 'HANAR' },
{ value: 'VICTE', text: 'VICTE' },
{ value: 'SUPRD', text: 'SUPRD' },
];
public fields = { value: 'value', text: 'text' };
ngOnInit(): void {
this.data = data;
this.orderIDRules = { required: true };
this.customerIDRules = { required: true, minLength: 5 };
this.freightRules = { required: true, min: 1, max: 1000 };
this.editSettings = {
allowEditing: true,
allowAdding: true,
allowDeleting: true,
};
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
}
actionBegin(args: SaveEventArgs) {
if (args.requestType === 'beginEdit' || args.requestType === 'add') {
(this.orderData as object) = Object.assign({}, args.rowData);
}
if (args.requestType === 'save') {
(args.data as columnDataType)['CustomerID'] = this.orderData['CustomerID'];
}
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Render MaskedTextBox in the edit form
The Data Grid allows rendering an MaskedTextBox component within the grid’s edit form for a specific column. This feature is especially useful when there is a need to provide masked input fields that require a specific format, such as phone numbers or postal codes.
To render a MaskedTextBox component in the edit form, it is necessary to define an editTemplate for the column using ng-template. The editTemplate property specifies the cell edit template that used as an editor for a particular column. It can accept either a template string or an HTML element ID.
Here’s an example to render a MaskedTextBox component in the “Customer Number” column of the Syncfusion Grid. The actionBegin event is handled to update the edited value in the grid when the save button is clicked:
import { columnDataType, data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, DropDownListModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, ForeignKeyService, GridModule, PageService, SaveEventArgs, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { MaskedTextBoxModule, TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule,
DropDownListModule,
MaskedTextBoxModule
],
providers: [EditService, ToolbarService, SortService, PageService, ForeignKeyService],
standalone: true,
selector: 'app-root',
template: `
<ejs-grid #grid [dataSource]='data' [allowPaging]='true' height='220px'
[editSettings]='editSettings' [toolbar]='toolbar'
(actionBegin)='actionBegin($event)'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' type='number' textAlign='Right' isPrimaryKey='true'
width="100"></e-column>
<e-column field='CustomerID' headerText='Customer ID' type='string' width="120"></e-column>
<e-column field='ShipCountry' headerText='Ship Country' width="100"></e-column>
<e-column field='CustomerNumber' headerText='Customer Number' width="140">
<ng-template #editTemplate let-data>
<ejs-maskedtextbox id="masktextbox" #mask name="CustomerNumber" mask='000-000-0000'
[(value)]="orderData.CustomerNumber"></ejs-maskedtextbox>
</ng-template>
</e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public orderData?: object | any;
public orderIDRules?: object;
public customerIDRules?: object;
public freightRules?: object;
ngOnInit(): void {
this.data = data;
this.orderIDRules = { required: true };
this.customerIDRules = { required: true, minLength: 5 };
this.editSettings = {
allowEditing: true,
allowAdding: true,
allowDeleting: true,
};
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
}
actionBegin(args: SaveEventArgs) {
if (args.requestType === 'beginEdit' || args.requestType === 'add') {
this.orderData = Object.assign({}, args.rowData);
}
if (args.requestType === 'save') {
(args.data as columnDataType)['CustomerNumber'] = this.orderData['CustomerNumber'];
}
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Render DropDownList in edit form
The Data Grid allows rendering a DropDownList component within the Grid’s edit form for a specific column. This feature is valuable when there is a need to provide a convenient way to select options from a predefined list while editing data in the grid’s edit form.
To render a DropDownList component in the edit form, it is necessary to define an editTemplate for the column using ng-template. The editTemplate property specifies the cell edit template that used as an editor for a particular column. It can accept either a template string or an HTML element ID.
The following example demonstrates how to render a DropDownList component in the “Ship Country” column of the grid. The actionBegin event is handled to update the edited value in the grid when the save button is clicked:
import { columnDataType, data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, DropDownListModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, PageService, SaveEventArgs, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule,
DropDownListModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='273px'
(actionBegin)='actionBegin($event)'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right'
isPrimaryKey='true' [validationRules]='orderIDRules'></e-column>
<e-column field='CustomerID' headerText='Customer Name' width='120'>
</e-column>
<e-column field='Freight' headerText='Freight' width='120' format='C2' textAlign='Right'
editType='numericedit' [validationRules]='freightRules'></e-column>
<e-column field='OrderDate' headerText='Order Date' width='130' editType='datepickeredit'
format='yMd' textAlign='Right'></e-column>
<e-column field='ShipCountry' headerText='Ship Country' width='150'>
<ng-template #editTemplate let-data>
<ejs-dropdownlist [dataSource]='selectDatasource' [(value)]='orderData.ShipCountry'></ejs-dropdownlist>
</ng-template>
</e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public orderData?: object | any;
public orderIDRules?: object;
public customerIDRules?: object;
public freightRules?: object;
public selectDatasource = [
{ text: 'Germany', value: 'Germany' },
{ text: 'Brazil', value: 'Brazil' },
{ text: 'Belgium', value: 'Belgium' },
{ text: 'Switzerland', value: 'Switzerland' },
{ text: 'Venezuela', value: 'Venezuela' },
{ text: 'Austria', value: 'Austria' },
{ text: 'Mexico', value: 'Mexico' },
];
public fields = { value: 'value', text: 'text' };
ngOnInit(): void {
this.data = data;
this.orderIDRules = { required: true };
this.customerIDRules = { required: true, minLength: 5 };
this.freightRules = { required: true, min: 1, max: 1000 };
this.editSettings = {
allowEditing: true,
allowAdding: true,
allowDeleting: true,
};
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
}
actionBegin(args: SaveEventArgs) {
if (args.requestType === 'beginEdit' || args.requestType === 'add') {
this.orderData = Object.assign({}, args.rowData);
}
if (args.requestType === 'save') {
(args.data as columnDataType)['ShipCountry'] = this.orderData['ShipCountry'];
}
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Render images in the DropDownList using item template
The Data Grid allows rendering images in the DropDownList editor component. This feature is valuable when there is a need to display images for each item in the dropdown list of a particular column, enhancing the visual representation of the data.
To render a DropDownList in the edit form, it is necessary to define an editTemplate for the column using ng-template. The editTemplate property specifies the cell edit template that is used as an editor for a particular column. It can accept either a template string or an HTML element ID.
To display an image in the DropDownList editor component, the itemTemplate property can be utilized. This property allows customization of the content of each item in the dropdown list.
The following example demonstrates how to render images in the DropDownList editor component using the itemTemplate within the “Employee Name” column of the Syncfusion grid. Additionally, the actionBegin event is handled to update the edited value in the grid when the save button is clicked:
import { FormsModule } from '@angular/forms';
import { GridModule, SortService, PageService } from '@syncfusion/ej2-angular-grids';
import { DatePickerAllModule } from '@syncfusion/ej2-angular-calendars'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'
import { DropDownListModule } from '@syncfusion/ej2-angular-dropdowns'
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs'
import { MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns'
import { AutoCompleteModule } from '@syncfusion/ej2-angular-dropdowns'
import { Component, ViewChild } from '@angular/core';
import { columnDataType, data, employeeData } from './datasource';
import { GridComponent, EditService, ToolbarService, ToolbarItems, EditSettingsModel, ForeignKeyService, SaveEventArgs } from '@syncfusion/ej2-angular-grids';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule,
DropDownListModule
],
providers: [EditService, ToolbarService, SortService, PageService, ForeignKeyService],
standalone: true,
selector: 'app-root',
template: `
<ejs-grid #grid [dataSource]="data" [allowPaging]="true" [pageSettings]="pageSettings" (actionBegin)="actionBegin($event)" [editSettings]="editOptions" [toolbar]="toolbarItems" height="220" >
<e-columns>
<e-column field="OrderID" headerText="Order ID" width="120" textAlign="Right" [validationRules]="orderIDRules" isPrimaryKey="true"></e-column>
<e-column field="EmployeeID" foreignKeyValue='FirstName' foreignKeyField='EmployeeID' [dataSource]='employeeData' headerText="Employee Name" width="220">
<ng-template #editTemplate let-data>
<ejs-dropdownlist [dataSource]='employeeData' [(ngModel)]="orderData.EmployeeID" [fields]='dropdownFields' [itemTemplate]="itemTemplate">
<ng-template #itemTemplate let-data>
<div>
<img class="empImage" width="50px" [src]="'https://ej2.syncfusion.com/demos/src/grid/images/' + data.EmployeeID + '.png'" alt="employee" />
<div class="ename">{{ data.FirstName }}</div>
</div>
</ng-template>
</ejs-dropdownlist>
</ng-template>
</e-column>
<e-column field="Freight" headerText="Freight" width="100" format="C2" textAlign="Right" editType="numericedit"></e-column>
<e-column field="ShipName" headerText="Ship Name" width="170"></e-column>
<e-column field="ShipCountry" headerText="Ship Country" width="150" editType="dropdownedit"></e-column>
</e-columns>
</ejs-grid>`,
})
export class AppComponent {
public data?: Object[];
public pageSettings?: Object;
public toolbarItems?: ToolbarItems[];
public editOptions?: EditSettingsModel;
public employeeData?: Object;
public orderIDRules?: Object;
public orderData?: object | any;
public dropdownFields?: Object;
@ViewChild('grid')
public grid?: GridComponent;
public ngOnInit(): void {
this.data = data;
this.pageSettings = { pageCount: 5 };
this.toolbarItems = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
this.employeeData = employeeData;
this.editOptions = {
allowEditing: true,
allowAdding: true,
allowDeleting: true,
mode: 'Normal',
};
this.orderIDRules = { required: true };
this.dropdownFields = { text: 'FirstName', value: 'EmployeeID' };
}
actionBegin(args: SaveEventArgs) {
if (args.requestType === 'beginEdit' || args.requestType === 'add') {
this.orderData = Object.assign({}, args.rowData);
}
if (args.requestType === 'save') {
(args.data as columnDataType)['EmployeeID'] = this.orderData['EmployeeID'];
}
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Render multiple columns in DropDownList
The Data Grid supports rendering a DropDownList component within the Grid’s edit form for a specific column. This feature is useful for displaying detailed information for each item in the dropdown list during column editing.
Define an editTemplate for the column using ng-template. The editTemplate property specifies the cell edit template used as an editor for a particular column and can accept either a template string or an HTML element ID.
The DropDownList has been provided with several options to customize each list item, group title, selected value, header, and footer element. By default, list items can be rendered as a single column in the DropDownList component. Instead of this, multiple columns can be rendered. This can be achieved by using the headerTemplate and itemTemplate properties of the DropDownList component.
The following example demonstrates how to render a DropDownList component with multiple columns within in the “Ship Country” column. The actionBegin event is handled to update the edited value in the grid when the save button is clicked:
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule , TimePickerModule} from '@syncfusion/ej2-angular-calendars';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
import { MultiSelectModule, DropDownListModule, AutoCompleteModule } from '@syncfusion/ej2-angular-dropdowns';
import { Component, OnInit } from '@angular/core';
import { columnDataType, data } from './datasource';
import { GridModule, EditService, ToolbarService, SortService, PageService, EditSettingsModel, ToolbarItems,SaveEventArgs } from '@syncfusion/ej2-angular-grids';
import { Query } from '@syncfusion/ej2-data';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule,
DropDownListModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='273px'
(actionBegin)='actionBegin($event)'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right'
isPrimaryKey='true' [validationRules]='orderIDRules'></e-column>
<e-column field='CustomerID' headerText='Customer Name' width='120'></e-column>
<e-column field='Freight' headerText='Freight' width='120' format='C2' textAlign='Right'
editType='numericedit' [validationRules]='freightRules'></e-column>
<e-column field='OrderDate' headerText='Order Date' width='130' editType='datepickeredit'
format='yMd' textAlign='Right'></e-column>
<e-column field='ShipCountry' headerText='Ship Country' width=300>
<ng-template #editTemplate let-data3>
<ejs-dropdownlist [dataSource]='data'
[fields]='fields' [query]='query' [(value)]="orderData.ShipCountry">
<ng-template #headerTemplate="" let-data2="">
<table><tr><th>EmployeeID</th><th>ShipCountry</th></tr></table>
</ng-template>
<ng-template #itemTemplate let-data1>
<div class="e-grid">
<table class="e-table">
<tbody>
<tr>
<td class="e-rowcell">{{ data1.EmployeeID }}</td>
<td class="e-rowcell">{{ data1.ShipCountry }}</td>
</tr>
</tbody>
</table>
</div>
</ng-template>
</ejs-dropdownlist>
</ng-template>
</e-column>
</e-columns>
</ejs-grid>`,
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public orderData?: object | any;
public orderIDRules?: object;
public freightRules?: object;
public fields = { text: 'ShipCountry' };
public query: Query = new Query()
.from('data')
.select(['EmployeeID', 'ShipCountry', 'OrderID'])
.take(6);
ngOnInit(): void {
this.data = data;
this.orderIDRules = { required: true };
this.freightRules = { required: true, min: 1, max: 1000 };
this.editSettings = {
allowEditing: true,
allowAdding: true,
allowDeleting: true,
};
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
}
actionBegin(args: SaveEventArgs) {
if (args.requestType === 'beginEdit' || args.requestType === 'add') {
this.orderData = Object.assign({}, args.rowData);
}
if (args.requestType === 'save') {
(args.data as columnDataType)['ShipCountry'] = this.orderData['ShipCountry'];
}
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Render ComboBox in edit form
The Data Grid supports rendering a ComboBox component within the Grid’s edit form for a specific column. This feature is useful for providing a drop-down selection with auto-suggestions for data entry.
Define an editTemplate for the column using ng-template. The editTemplate property specifies the cell edit template used as an editor for a particular column and can accept either a template string or an HTML element ID.
The following example demonstrates how to render a ComboBox component in the “Ship Country” column of the Syncfusion Grid. The actionBegin event is handled to update the edited value in the grid when the save button is clicked:
import { columnDataType, data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, ComboBoxModule, DropDownListModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, PageService, SaveEventArgs, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule,
ComboBoxModule ,
DropDownListModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='273px'
(actionBegin)='actionBegin($event)'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey='true'
[validationRules]='orderIDRules'></e-column>
<e-column field='CustomerID' headerText='Customer Name' width='120'></e-column>
<e-column field='Freight' headerText='Freight' width='120' format='C2' textAlign='Right'
editType='numericedit' [validationRules]='freightRules'></e-column>
<e-column field='OrderDate' headerText='Order Date' width='130' editType='datepickeredit'
format='yMd' textAlign='Right'></e-column>
<e-column field='ShipCountry' headerText='Ship Country' width='150'>
<ng-template #editTemplate let-data>
<ejs-combobox [dataSource]='selectDatasource' [(ngModel)]='orderData.ShipCountry'></ejs-combobox>
</ng-template>
</e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public orderData?: object | any;
public orderIDRules?: object;
public customerIDRules?: object;
public freightRules?: object;
public selectDatasource = [
{ text: 'Germany', value: 'Germany' },
{ text: 'Brazil', value: 'Brazil' },
{ text: 'Belgium', value: 'Belgium' },
{ text: 'Switzerland', value: 'Switzerland' },
{ text: 'Venezuela', value: 'Venezuela' },
{ text: 'Austria', value: 'Austria' },
{ text: 'Mexico', value: 'Mexico' },
];
public fields = { value: 'value', text: 'text' };
ngOnInit(): void {
this.data = data;
this.orderIDRules = { required: true };
this.freightRules = { required: true, min: 1, max: 1000 };
this.editSettings = {
allowEditing: true,
allowAdding: true,
allowDeleting: true,
};
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
}
actionBegin(args: SaveEventArgs) {
if (args.requestType === 'beginEdit' || args.requestType === 'add') {
this.orderData = Object.assign({}, args.rowData);
}
if (args.requestType === 'save') {
(args.data as columnDataType)['ShipCountry'] = this.orderData['ShipCountry'];
}
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Render TimePicker in edit form
The Data Grid supports rendering a TimePicker component within the grid’s edit form for a specific column. This feature is useful for providing a time input, such as appointment times or event schedules, for editing in the grid.
Define an editTemplate for the column using ng-template. The editTemplate property specifies the cell edit template used as an editor for a particular column and can accept either a template string or an HTML element ID.
The following example demonstrates how to render a TimePicker component in the “Order Date” column of the Syncfusion Grid. The actionBegin event is handled to update the edited value in the grid when the save button is clicked:
import { columnDataType, data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, PageService, SaveEventArgs, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='273px'
(actionBegin)='actionBegin($event)'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right' isPrimaryKey='true' [validationRules]='orderIDRules'></e-column>
<e-column field='CustomerID' headerText='Customer Name' width='120'></e-column>
<e-column field='Freight' headerText='Freight' width='120' format='C2' textAlign='Right' >
</e-column>
<e-column field='ShipCountry' headerText='Ship Country' width='150'>
</e-column>
<e-column field='OrderDate' headerText='Order Date' width='140'
format='yMd' editType="DatePickerEdit" textAlign='Right'></e-column>
<e-column field='OrderDate' headerText='Order Time' width='140'
format='hh :mm a ' textAlign='Right'>
<ng-template #editTemplate let-data>
<ejs-timepicker [(value)]='orderData.OrderDate'></ejs-timepicker >
</ng-template>
</e-column>
<e-column field='ShipCountry' headerText='Ship Country' width='150'>
</e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public orderData?: object | any;
public orderIDRules?: object;
public customerIDRules?: object;
public freightRules?: object;
ngOnInit(): void {
this.data = data;
this.orderIDRules = { required: true };
// this customerIDRules = { required: true, minLength: 5 };
this.freightRules = { required: true, min: 1, max: 1000 };
this.editSettings = {
allowEditing: true,
allowAdding: true,
allowDeleting: true,
};
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
}
actionBegin(args: SaveEventArgs) {
if (args.requestType === 'beginEdit' || args.requestType === 'add') {
this.orderData = Object.assign({}, args.rowData);
}
if (args.requestType === 'save') {
(args.data as columnDataType)['OrderDate'] = this.orderData['OrderDate'];
}
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Render MultiSelect in edit form
The Data Grid supports rendering a MultiSelect component within the Grid’s edit form, enabling selection of multiple values from a dropdown list when editing a specific column. This feature is useful when multiple selections are required for a column.
Define an editTemplate for the column using ng-template. The editTemplate property specifies the cell edit template used as an editor for a particular column and can accept either a template string or an HTML element ID.
The following example demonstrates how to render a MultiSelect component in the “Ship City” column of the Syncfusion Grid. The actionBegin event is handled to update the edited value in the grid when the save button is clicked:
import { columnType, data } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, PageService, SaveEventArgs, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='273px' (actionBegin)='actionBegin($event)' >
<e-columns>
<e-column field='OrderID' headerText='Order ID' width='120' textAlign='Right'
isPrimaryKey='true' [validationRules]='orderIDRules'></e-column>
<e-column field='CustomerID' headerText='Customer Name' width='120'></e-column>
<e-column field='Freight' headerText='Freight' width='120' format='C2' textAlign='Right'
editType='numericedit' [validationRules]='freightRules'></e-column>
<e-column field='OrderDate' headerText='Order Date' width='130' editType='datepickeredit'
format='yMd' textAlign='Right'></e-column>
<e-column field='ShipCity' headerText='Ship City' width='150'>
<ng-template #editTemplate let-data>
<ejs-multiselect [dataSource]='multiselectDatasource'
[(value)]="orderData.ShipCity" [fields]='fields'></ejs-multiselect>
</ng-template>
</e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public orderData: { ShipCity: string[] } = { ShipCity: [] };
public orderIDRules?: object;
public customerIDRules?: object;
public freightRules?: object;
public multiselectDatasource = [
{ value: 'Reims', text: 'Reims' },
{ value: 'Münster', text: 'Münster' },
{ value: 'Rio de Janeiro', text: 'Rio de Janeiro' },
{ value: 'Lyon', text: 'Lyon' },
{ value: 'Charleroi', text: 'Charleroi' }
];
public fields = { value: 'value', text: 'text' };
ngOnInit(): void {
this.data = data;
this.orderIDRules = { required: true };
this.customerIDRules = { required: true, minLength: 5 };
this.freightRules = { required: true, min: 1, max: 1000 };
this.editSettings = {
allowEditing: true,
allowAdding: true,
allowDeleting: true,
};
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
}
actionBegin(args: SaveEventArgs) {
if (args.requestType === 'beginEdit' || args.requestType === 'add') {
(this.orderData as Object)= Object.assign({}, args.rowData);
(this.orderData as columnDataType)['ShipCity'] = (this.orderData as columnDataType)['ShipCity']? ((this.orderData as columnDataType)['ShipCity'] as any).split(','):[];
}
if (args.requestType === 'save') {
(args.data as columnType)['ShipCity'] = (this.orderData as columnDataType)['ShipCity'].join(',');
}
}
}
export interface columnDataType{
ShipCity: string[];
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Render RichTextEditor in edit form
The Data Grid allows rendering the RichTextEditor component within the edit form. This enables formatting and styling text content using bold, italic, underline, bullet lists, numbered lists, and other formatting options.
Define an editTemplate for the column using ng-template. The editTemplate property specifies the cell edit template used as an editor for a particular column and can accept either a template string or an HTML element ID.
Set the allowTextWrap property of the corresponding grid column to true. Enabling this property allows the rich text editor component to adjust its width and wrap text content to fit within the boundaries of the column.
The following example demonstrates how to render a RichTextEditor component in the “Ship Address” column of the Syncfusion Grid. The actionBegin event is handled to update the edited value in the grid when the save button is clicked:
import { columnDataType, data } from './datasource';
import { CommonModule } from '@angular/common';
import { Component, OnInit, ViewChild } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridComponent, GridModule, IEditCell, PageService, PageSettingsModel, SaveEventArgs, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { FocusInEventArgs, TextBoxModule } from '@syncfusion/ej2-angular-inputs';
import { RichTextEditorAllModule } from '@syncfusion/ej2-angular-richtexteditor';
@Component({
imports: [
CommonModule,
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule,
RichTextEditorAllModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `
<ejs-grid #normalgrid [dataSource]="data" allowPaging="true" [pageSettings]="pageOptions"
[editSettings]="editSettings" [toolbar]="toolbar" (actionBegin)="actionBegin($event)" height='220px'>
<e-columns>
<e-column field="OrderID" headerText="Order ID" width="100" textAlign="Right" isPrimaryKey="true"
[validationRules]="orderIDRules">
</e-column>
<e-column field="CustomerID" headerText="Customer ID" [validationRules]="customerIDRules" width="100"></e-column>
<e-column field="Freight" headerText="Freight" width="100" format="C2" textAlign="Right"
editType="numericedit" [validationRules]="freightRules">
</e-column>
<e-column field="OrderDate" headerText="Order Date" width="100" editType="datetimepickeredit"
[format]="formatoptions" textAlign="Right">
</e-column>
<e-column field="ShipAddress" headerText="Ship Address" width="150" editType="textarea" [disableHtmlEncode]="false">
<ng-template #editTemplate let-data1>
<div *ngIf="orderData && orderData.ShipAddress !== undefined">
<ejs-richtexteditor id="rteEdit" [(value)]="orderData.ShipAddress" (focus)="onFocus($event)" #rteEdit>
</ejs-richtexteditor>
</div>
</ng-template>
</e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public orderData: object | any;
public orderIDRules?: Object;
public customerIDRules?: Object;
public freightRules?: Object;
public editParams?: IEditCell;
public formatoptions?: Object;
public pageOptions?: PageSettingsModel;
@ViewChild('normalgrid') public grid?: GridComponent;
ngOnInit(): void {
this.data = data;
this.orderIDRules = { required: true, number: true };
this.customerIDRules = { required: true };
this.freightRules = { required: true };
this.formatoptions = { type: 'dateTime', format: 'M/d/y hh:mm a' };
this.editSettings = {
allowEditing: true,
allowAdding: true,
allowDeleting: true,
};
this.pageOptions = { pageSizes: true, pageSize: 8 };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
}
actionBegin(args: SaveEventArgs) {
if (args.requestType === 'beginEdit' || args.requestType === 'add') {
this.orderData = Object.assign({}, args.rowData);
}
if (args.requestType === 'save') {
(args.data as columnDataType)['ShipAddress'] = this.orderData['ShipAddress'];
}
}
onFocus(args: FocusInEventArgs): void {
((args.event as Event).target as EventTarget).addEventListener('keydown', (e) => {
if ((e as KeyboardEvent).key === 'Enter') {
e.stopPropagation();
}
});
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Render Uploader in edit form
The Data Grid allows rendering an Uploader component within the grid’s edit form. This enables uploading and managing files or images in a specific column during data editing.
Define an editTemplate for the column using ng-template. The editTemplate property specifies the cell edit template used as an editor for a particular column and can accept either a template string or an HTML element ID.
The following example demonstrates how to render a Uploader component in the “Order Image” column of the Syncfusion Grid. The actionBegin event is handled to update the edited value in the grid when the save button is clicked:
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
import { MultiSelectModule, DropDownListModule, AutoCompleteModule } from '@syncfusion/ej2-angular-dropdowns';
import { UploaderModule } from '@syncfusion/ej2-angular-inputs';
import { Component, OnInit, NgModule } from '@angular/core';
import { employeeData } from './datasource';
import { EditSettingsModel,ToolbarItems,SaveEventArgs, GridModule, EditService, ToolbarService, SortService, PageService } from '@syncfusion/ej2-angular-grids';
import { FileInfo, SuccessEventArgs } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule,
UploaderModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `
<ejs-grid [dataSource]='data' allowPaging='true' height='220px' [editSettings]='editSettings' [toolbar]='toolbar' (actionBegin)='actionBegin($event)'>
<e-columns>
<e-column field='EmployeeID' headerText='Employee ID' textAlign='Right' isPrimaryKey='true' width=100></e-column>
<e-column field='FirstName' headerText='First Name' textAlign='Left' width=120></e-column>
<e-column field='LastName' headerText='Last Name' textAlign='Left' width=120></e-column>
<e-column field='Title' headerText='Title' textAlign='Left' width=120 ></e-column>
<e-column headerText='Employee Image' width='150' textAlign='Center'>
<ng-template #template let-data>
<div class="image">
<img [src]="!data.Image ? 'https://ej2.syncfusion.com/angular/demos/assets/grid/images/' + data.EmployeeID + '.png' : data.Image" alt="{{data.EmployeeID}}" />
</div>
</ng-template>
<ng-template #editTemplate let-data>
<ejs-uploader #defaultupload (success)="onUploadSuccess($event)" [asyncSettings]='path' multiple='false'></ejs-uploader>
</ng-template>
</e-column>
</e-columns>
</ejs-grid>
`,
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public orderData?: object | any;
public orderIDRules?: object;
public customerIDRules?: object;
public freightRules?: object;
public strm?:string;
public path: object = {
saveUrl: 'https://services.syncfusion.com/angular/production/api/FileUploader/Save',
removeUrl: 'https://services.syncfusion.com/angular/production/api/FileUploader/Remove'
};
ngOnInit(): void {
this.data = employeeData;
this.orderIDRules = { required: true };
this.customerIDRules = { required: true, minLength: 5 };
this.freightRules = { required: true, min: 1, max: 1000 };
this.editSettings = {
allowEditing: true,
allowAdding: true,
allowDeleting: true,
};
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
}
actionBegin(args: SaveEventArgs) {
if (args.requestType === 'beginEdit' || args.requestType === 'add') {
this.orderData = Object.assign({}, args.rowData);
}
if (args.requestType === 'save') {
(args.data as columnDataType)['Image'] = this.strm;
}
}
onUploadSuccess(args: SuccessEventArgs) {
if (args.operation === 'upload') {
const fileBlob = (args.file as FileInfo).rawFile as Blob;
const file = new File([fileBlob], (args.file as FileInfo).name);
this.strm = this.getBase64(file);
}
}
getBase64(file:File): string {
const reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = () => {
this.strm = reader.result as string;
};
return (this.strm as string);
}
}
export interface columnDataType{
Image?: string;
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));To prevent accidentally closing the cell editor (particularly with complex custom editors), add the
edit-custom-templateclass to custom component roots and set thecssClassproperty to includeedit-custom-templatefor Syncfusion editors when needed.
Rendering custom cell editors using external functions
The Data Grid provides flexible support for rendering custom cell editors, enabling the addition of specialized custom components to specific columns. This is useful for editing cell values using custom input elements or controls tailored to specific data types or workflows.
To utilize the custom cell editor template feature, implement these four essential functions:
| Function | Purpose | When Triggered |
|---|---|---|
create |
Create the DOM element or component container | During component initialization |
write |
Create the custom component and assign default values | When editing begins on the cell |
read |
Extract and return the edited value from the component | When saving changes to the cell |
destroy |
Clean up and remove the component | When exiting edit mode or closing the editor |
Render AutoComplete in edit form
Define a custom editor with the edit API for AutoComplete in the “Customer ID” column:
import { purchaseData } from './datasource';
import { Component, OnInit, ViewChild } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridComponent, GridModule, IEditCell, PageService, PageSettingsModel, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
import { AutoComplete } from '@syncfusion/ej2-dropdowns';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `
<ejs-grid #grid [dataSource]='data' [allowPaging]='true' [editSettings]='editSettings' [pageSettings]='pageOptions' [toolbar]='toolbar' height='220px'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' type='number' textAlign='Right' isPrimaryKey='true' width=100></e-column>
<e-column field='CustomerID' headerText='Customer ID' type= 'string' [edit]='daParams' width=140></e-column>
<e-column field='Freight' headerText='Freight' type= 'number' textAlign= 'Right' editType= 'numericedit' format= 'C2' width=120></e-column>
<e-column field='OrderDate' headerText='Order Date' type= 'date' format= 'yMd' editType= 'datepickeredit' width=150></e-column>
</e-columns>
</ejs-grid>`,
})
export class AppComponent implements OnInit {
public data?: object[];
@ViewChild('grid') public grid?: GridComponent;
public editSettings?: EditSettingsModel;
public pageOptions?: PageSettingsModel;
public toolbar?: ToolbarItems[];
public daParams?: IEditCell;
public inpuEle?: HTMLElement;
public autoCompleteIns?: AutoComplete;
public autoCompleteData: { [key: string]: Object }[] = [
{ CustomerID: 'VINET', Id: '1' },
{ CustomerID: 'TOMSP', Id: '2' },
{ CustomerID: 'HANAR', Id: '3' },
{ CustomerID: 'VICTE', Id: '4' },
{ CustomerID: 'SUPRD', Id: '5' },
];
public createCustomerIDFn = () => {
this.inpuEle = document.createElement('input');
return this.inpuEle;
}
public destroyCustomerIDFn = () => {
this.autoCompleteIns?.destroy();
}
public readCustomerIDFn = () => {
return this.autoCompleteIns?.value;
}
public writeCustomerIDFn = (args: any) => {
this.autoCompleteIns = new AutoComplete({
allowCustom: true,
value: args.rowData[args.column.field],
dataSource: this.autoCompleteData ,
fields: { value: 'CustomerID', text: 'CustomerID' },
});
this.autoCompleteIns?.appendTo(this.inpuEle);
}
ngOnInit(): void {
this.data = purchaseData;
this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
this.pageOptions = { pageSizes: true, pageSize: 8 };
this.daParams = {
create: this.createCustomerIDFn,
read: this.readCustomerIDFn,
destroy: this.destroyCustomerIDFn,
write: this.writeCustomerIDFn
};
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Render cascading DropDownList in edit form
Create cascading DropDownLists (e.g., country and state) by configuring a custom editor with appropriate edit methods.
import { cascadeData } from './datasource';
import { Component, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditService, EditSettingsModel, GridModule, IEditCell, PageService, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
import { DataManager, Query } from '@syncfusion/ej2-data';
import { DropDownList } from '@syncfusion/ej2-dropdowns';
@Component({
imports: [
GridModule,
DatePickerAllModule,
FormsModule,
TimePickerModule,
FormsModule,
TextBoxModule,
MultiSelectModule,
AutoCompleteModule
],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `
<ejs-grid [dataSource]='data' [editSettings]='editSettings' [toolbar]='toolbar' height='273px'>
<e-columns>
<e-column field='OrderID' headerText='Order ID' textAlign='Right' isPrimaryKey='true' width=100></e-column>
<e-column field='CustomerID' headerText='Customer ID' width=120></e-column>
<e-column field='ShipCountry' headerText='Ship Country' editType= 'dropdownedit'
[edit]='countryParams' width=150></e-column>
<e-column field='ShipState' headerText='Ship State' editType= 'dropdownedit' [edit]='stateParams' width=150></e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent implements OnInit {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public countryParams?: IEditCell;
public stateParams?: IEditCell;
public countryElem?: HTMLElement;
public countryObj?: DropDownList;
public stateElem?: HTMLElement;
public stateObj?: DropDownList | undefined;
public country: object[] = [
{ countryName: 'United States', countryId: '1' },
{ countryName: 'Australia', countryId: '2' }
];
public state: object[] = [
{ stateName: 'New York', countryId: '1', stateId: '101' },
{ stateName: 'Virginia ', countryId: '1', stateId: '102' },
{ stateName: 'Washington', countryId: '1', stateId: '103' },
{ stateName: 'Queensland', countryId: '2', stateId: '104' },
{ stateName: 'Tasmania ', countryId: '2', stateId: '105' },
{ stateName: 'Victoria', countryId: '2', stateId: '106' }
];
ngOnInit(): void {
this.data = cascadeData;
this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true };
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
this.countryParams = {
create: () => {
this.countryElem = document.createElement('input');
return this.countryElem;
},
read: () => {
return (this.countryObj as DropDownList).text;
},
destroy: () => {
(this.countryObj as DropDownList).destroy();
},
write: () => {
this.countryObj = new DropDownList({
dataSource: new DataManager(this.country),
fields: { value: 'countryId', text: 'countryName' },
change: () => {
(this.stateObj as DropDownList).enabled = true;
const tempQuery: Query = new Query().where('countryId', 'equal', (this.countryObj as DropDownList).value as string);
(this.stateObj as DropDownList).query = tempQuery;
((this.stateObj as DropDownList).text as string) = '';
(this.stateObj as DropDownList).dataBind();
},
placeholder: 'Select a country',
floatLabelType: 'Never'
});
this.countryObj.appendTo(this.countryElem);
}
};
this.stateParams = {
create: () => {
this.stateElem = document.createElement('input');
return this.stateElem;
},
read: () => {
return (this.stateObj as DropDownList).text;
},
destroy: () => {
(this.stateObj as DropDownList).destroy();
},
write: () => {
this.stateObj = new DropDownList({
dataSource: new DataManager(this.state),
fields: { value: 'stateId', text: 'stateName' },
enabled: false,
placeholder: 'Select a state',
floatLabelType: 'Never'
});
this.stateObj.appendTo(this.stateElem);
}
};
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));Access editor component instances
Accessing editor components in the Data Grid enables direct interaction with editor instances associated with cells during editing or adding actions. This feature is especially valuable when performing custom actions, retrieving data from the editor, or manipulating its properties during editing or adding operations in the grid.
Access the component instance from the component element using the ej2_instances property. This property provides access to the instance of the editor component associated with a cell.
In the below demo, access the editor component instance while adding or editing actions in the actionComplete event.
import { data } from './datasource';
import { Component } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { DatePickerAllModule, TimePickerModule } from '@syncfusion/ej2-angular-calendars';
import { AutoCompleteModule, DropDownListModule, MultiSelectModule } from '@syncfusion/ej2-angular-dropdowns';
import { EditEventArgs, EditService, EditSettingsModel, GridModule, PageService, SortService, ToolbarItems, ToolbarService } from '@syncfusion/ej2-angular-grids';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';
@Component({
imports: [ GridModule, DatePickerAllModule,FormsModule, TimePickerModule, FormsModule,TextBoxModule, MultiSelectModule, AutoCompleteModule, DropDownListModule ],
providers: [EditService, ToolbarService, SortService, PageService],
standalone: true,
selector: 'app-root',
template: `
<ejs-grid [dataSource]="data" height='250px' [editSettings]="editSettings" [toolbar]="toolbar" (actionComplete)="access($event)">
<e-columns>
<e-column field="OrderID" headerText="Order ID" isPrimaryKey="true" textAlign="Right" width="100"></e-column>
<e-column field="CustomerID" headerText="Customer ID" type="string" [validationRules]='customerIDRules'
width="120"></e-column>
<e-column field="Freight" headerText="Freight" textAlign="Right" [validationRules]='freightRules'
format="C2" editType='numericedit' width="120" ></e-column>
<e-column field="ShipCountry" headerText="Ship Country" width="150" editType='dropdownedit'>
</e-column>
</e-columns>
</ejs-grid>`
})
export class AppComponent {
public data?: object[];
public editSettings?: EditSettingsModel;
public toolbar?: ToolbarItems[];
public orderIDRules?: Object;
public customerIDRules?: Object;
public freightRules?: Object;
ngOnInit(): void {
this.data = data;
this.editSettings = {
allowEditing: true,
allowAdding: true,
allowDeleting: true,
};
this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
this.orderIDRules = { required: true };
this.customerIDRules = { required: true };
this.freightRules = { required: true };
}
public access(args: EditEventArgs): void {
if (args.requestType === 'beginEdit' || args.requestType === 'add') {
const tr = args.row as HTMLTableRowElement;
const numericTextBox = tr.querySelector('.e-numerictextbox');
if (numericTextBox) {
const numericTextBoxInstance = (numericTextBox as HTMLFormElement)['ej2_instances'][0];
numericTextBoxInstance.element.style.backgroundColor = 'light pink';
numericTextBoxInstance.element.style.color = 'black';
numericTextBoxInstance.element.style.border = '2px solid red';
numericTextBoxInstance.element.style.textAlign = 'center';
numericTextBoxInstance.max = 1000;
numericTextBoxInstance.min = 1;
}
const dropDownList = tr.querySelector('.e-dropdownlist') ;
if (dropDownList) {
const dropDownListInstance = (dropDownList as HTMLFormElement)['ej2_instances'][0];
dropDownListInstance.showPopup(); // Open the dropdown list
}
}
}
}import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Edit types in Vue Grid component

16 Mar 202324 minutes to read

Customize editors using params

The columns.editType is used to define the editor component for any particular column.You can set the columns.editType based on data type of the column.

  • NumericTextBox component for integers, double, and decimal data types.

  • TextBox component for string data type.

  • DropDownList component to show all unique values related to that field.

  • Checkbox component for boolean type.

  • DatePicker component for date type.

Also, you can customize model of the columns.editType component through the columns.edit.params.

The following table describes cell edit type component and their corresponding edit params of the column.

Component Example
NumericTextBox params: { decimals: 2, value: 5 }
TextBox -
DropDownList params: { value: ‘Germany’ }
DatePicker params: { value: new Date()}
Checkbox params: { checked: true}
<template>
    <div id="app">
        <ejs-grid :dataSource='data' :editSettings='editSettings' :toolbar='toolbar' height='273px'>
            <e-columns>
                <e-column field='OrderID' headerText='Order ID' textAlign='Right' :isPrimaryKey='true' width=100></e-column>
                <e-column field='CustomerID' headerText='Customer ID' width=120></e-column>
                <e-column field='Freight' headerText='Freight' textAlign= 'Right' editType= 'numericedit' :edit='numericParams' width=120 format= 'C2'></e-column>
                <e-column field='ShipCountry' headerText='Ship Country' editType= 'dropdownedit' :edit='ddParams' width=150></e-column>
                <e-column field='ShippedDate' headerText='Shipped Date' editType= 'datepickeredit' :edit='dpParams' width=150></e-column>
                <e-column field='Verified' headerText='Verified' editType= 'booleanedit' :edit='boolParams' width=150></e-column>
            </e-columns>
        </ejs-grid>
    </div>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Page, Toolbar, Edit } from "@syncfusion/ej2-vue-grids";
import { data } from './datasource.js';

Vue.use(GridPlugin);

export default {
  data() {
    return {
      data: data,
      editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
      toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
      numericParams: { params: { decimals: 2, value: 5 } },
      ddParams: { params: { value: 'Germany' } },
      dpParams: { params: {value: new Date() } },
      boolParams: { params: {checked: true } }
    };
  },
  provide: {
    grid: [Page, Edit, Toolbar]
  }
}
</script>
<style>
 @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";
</style>

If edit type is not defined in the column, then it will be considered as the stringedit type (Textbox component).

Restrict to type decimal points in a NumericTextBox while editing the numeric column

By default, the number of decimal places will be restricted to two in the NumericTextBox while editing the numeric column. We can restrict to type the decimal points in a NumericTextBox by using the validateDecimalOnType and decimals properties of NumericTextBox.

In the below demo, while editing the row we have restricted to type the decimal point value in the NumericTextBox of Freight column.

<template>
    <div id="app">
        <ejs-grid :dataSource='data' :editSettings='editSettings' :toolbar='toolbar' height='265px' >
            <e-columns>
                <e-column field='OrderID' headerText='Order ID' :isPrimaryKey='true' textAlign='Right' width=100></e-column>
                <e-column field='CustomerID' headerText='Customer ID' width=120></e-column>
                <e-column field='Freight' headerText='Freight' textAlign='Center' editType='numericedit' :edit='numericParams' width=80></e-column>
             <e-column field='ShipCity' headerText='Ship City' editType='dropdownedit'  width=120></e-column>
            </e-columns>
        </ejs-grid>
    </div>
</template>
<script>
import Vue from "vue";
import { GridPlugin,Toolbar, Edit } from "@syncfusion/ej2-vue-grids";
import { data } from './datasource.js';

Vue.use(GridPlugin);
export default {
  data: () => {
    return {
      data: data,
      editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
      toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
      numericParams: { params: {
        validateDecimalOnType: true,
        decimals: 0,
        format: "N" }
      },
    };
  },
  provide: {
    grid: [Edit, Toolbar]
  }
}
</script>
<style>
  @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";
</style>

Provide custom data source and enabling filtering to DropDownList

You can provide data source to the DropDownList by using the columns.edit.params property.

While setting new data source using edit params, you must specify a new query property too for the DropDownList as follows,

countryParams: {
          params:   {
            allowFiltering: true,
            dataSource: country,
            fields: {text:"countryName",value:"countryName"},
            query: new Query(),
            actionComplete: () => false
            }
      };

You can also enable filtering for the DropDownList by passing the allowFiltering as true to the edit params.

In the below demo, DropDownList is rendered with custom Datasource for the ShipCountry column and enabled filtering to search DropDownList items.

<template>
    <div id="app">
        <ejs-grid ref='grid' :dataSource='data' :editSettings='editSettings' :toolbar='toolbar' height='273px' >
            <e-columns>
                <e-column field='OrderID' headerText='Order ID' :isPrimaryKey='true' textAlign='Right' width=100></e-column>
                <e-column field='CustomerID' headerText='Customer ID' width=120></e-column>
                <e-column field='ShipCountry' headerText='ShipCountry' editType='dropdownedit' :edit='countryParams' width=150></e-column>
            </e-columns>
        </ejs-grid>
    </div>
</template>
<script>
import Vue from "vue";
import { createElement } from '@syncfusion/ej2-base';
import { GridPlugin,Toolbar, Edit } from "@syncfusion/ej2-vue-grids";
import { DropDownList } from "@syncfusion/ej2-dropdowns";
import { Query } from '@syncfusion/ej2-data';
import { cascadeData } from './datasource.js';

let country= [
        { countryName: 'United States', countryId: '1' },
        { countryName: 'Australia', countryId: '2' },
        { countryName: 'India', countryId: '3' }
    ];
Vue.use(GridPlugin);
export default {
    data: () => {
      return {
        data: cascadeData,
        toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
        editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
        countryParams: {
          params:   {
            allowFiltering: true,
            dataSource: country,
            fields: {text:"countryName",value:"countryName"},
            query: new Query(),
            actionComplete: () => false
            }
        }
      };
    },
    provide: {
      grid: [Edit, Toolbar]
    }
  }
</script>
<style>
  @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";
</style>

Custom editors using template

The cell edit template is used to add a custom component for a particular column by invoking the following functions:

  • create - It is used to create the element at the time of initialization.

  • write - It is used to create custom component or assign default value at the time of editing.

  • read - It is used to read the value from the component at the time of save.

  • destroy - It is used to destroy the component.

Render TimePicker component while editing

Use the cell edit template feature of the Grid to render the TimePicker component in the Grid edit form. In the below sample, we have rendered TimePicker component in the OrderDate column.

<template>
    <div id="app">
        <ejs-grid ref='grid' :dataSource='data' :allowPaging='true' :editSettings='editSettings' :pageSettings='pageSettings' :toolbar='toolbar' height='175px'>
            <e-columns>
                <e-column field='OrderID' headerText='Order ID' type='number' textAlign='Right' :isPrimaryKey='true' :validationRules='orderIDRules' width=100></e-column>
                <e-column field='CustomerID' headerText='Customer ID' type='string' width=120>
                </e-column>
                <e-column field='Freight' headerText='Freight' type='number' textAlign='Right' editType='numericedit' format='C2' width=120></e-column>
                <e-column field='OrderDate' headerText='Order Date' type='date' textAlign='Right' format="hh:mm" :edit='dpParams' width=120></e-column>
            </e-columns>
        </ejs-grid>
    </div>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Page, Toolbar, Edit } from "@syncfusion/ej2-vue-grids";
import { TimePicker } from "@syncfusion/ej2-calendars";
import { enableRipple } from "@syncfusion/ej2-base";
import { purchaseData } from './datasource.js';

Vue.use(GridPlugin);

let ddElem;
let timeObject;

function createOrderDateFn() {
  ddElem = document.createElement('input');
  return ddElem;
}
function destroyOrderDateFn() {
  timeObject.destroy();
}
function readOrderDateFn() {
  return timeObject.value;
}
function writeOrderDateFn(args) {
  enableRipple(true);
  timeObject = new TimePicker({
    value: args.rowData[args.column.field],
    step: 60,
  });
  timeObject.appendTo(ddElem);
}

export default {
  data() {
    return {
      data: purchaseData,
      pageSettings: { pageSizes: true, pageSize: 5 },
      editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
      dpParams: {
        create: createOrderDateFn,
        destroy: destroyOrderDateFn,
        read: readOrderDateFn,
        write: writeOrderDateFn,
      },
      toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
      orderIDRules: { required: true },
    };
  },

  provide: {
    grid: [Page, Edit, Toolbar],
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";
</style>

Render AutoComplete component while editing

Use the cell edit template feature of the Grid to render the AutoComplete component in the Grid edit form. In the below sample, we have rendered AutoComplete component in the CustomerID column.

<template>
    <div id="app">
        <ejs-grid ref='grid' :dataSource='data' :allowPaging='true' :editSettings='editSettings' :pageSettings='pageSettings' :toolbar='toolbar' height='175px'>
            <e-columns>
                <e-column field='OrderID' headerText='Order ID' type='number' textAlign='Right' :isPrimaryKey='true' :validationRules='orderIDRules' width=100></e-column>
                <e-column field='CustomerID' headerText='Customer ID' type='string' :edit='daParams' width=140></e-column>
                <e-column field='Freight' headerText='Freight' type='number' textAlign='Right' editType='numericedit' format='C2' width=120></e-column>
                <e-column field='OrderDate' headerText='Order Date' type='date' editType='datepickeredit' textAlign='Right' format='yMd' width=150></e-column>
            </e-columns>
        </ejs-grid>
    </div>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Page, Toolbar, Edit } from "@syncfusion/ej2-vue-grids";
import { AutoComplete } from "@syncfusion/ej2-dropdowns";
import { purchaseData } from './datasource.js';

Vue.use(GridPlugin);

let inpuEle;
let autoCompleteIns;
let autoCompleteData = [
  { CustomerID: 'VINET', Id: '1' },
  { CustomerID: 'TOMSP', Id: '2' },
  { CustomerID: 'HANAR', Id: '3' },
  { CustomerID: 'VICTE', Id: '4' },
  { CustomerID: 'SUPRD', Id: '5' },
];

function createCustomerIDFn() {
  inpuEle = document.createElement('input');
  return inpuEle;
}
function destroyCustomerIDFn() {
  autoCompleteIns.destroy();
}
function readCustomerIDFn() {
  return autoCompleteIns.value;
}
function writeCustomerIDFn(args) {
  autoCompleteIns = new AutoComplete({
    allowCustom: true,
    value: args.rowData[args.column.field],
    dataSource: autoCompleteData,
    fields: { value: "CustomerID", text: "CustomerID" },
  });
  autoCompleteIns.appendTo(inpuEle);
}

export default {
  data() {
    return {
      data: purchaseData,
      pageSettings: { pageSizes: true, pageSize: 5 },
      editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
      daParams: {
        create: createCustomerIDFn,
        destroy: destroyCustomerIDFn,
        read: readCustomerIDFn,
        write: writeCustomerIDFn,
      },
      toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
      orderIDRules: { required: true },
    };
  },

  provide: {
    grid: [Page, Edit, Toolbar],
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";
</style>

Render MultiSelect DropDown component while editing

Use the cell edit template feature of the Grid to render the MultiSelect DropDown component in the Grid edit form. In the below sample, we have rendered MultiSelect DropDown component in the ShipCity column.

<template>
    <div id="app">
        <ejs-grid ref='grid' :dataSource='data' :allowPaging='true' :editSettings='editSettings' :pageSettings='pageSettings' :toolbar='toolbar' height='175px'>
            <e-columns>
                <e-column field='OrderID' headerText='Order ID' type='number' textAlign='Right' :isPrimaryKey='true' :validationRules='orderIDRules' width=100></e-column>
                <e-column field='CustomerID' headerText='Customer ID' type='string' width=120>
                </e-column>
                <e-column field='Freight' headerText='Freight' type='number' textAlign='Right' editType='numericedit' format='C2' width=120></e-column>
                <e-column field='ShipCity' headerText='Ship City' type='string' :edit='dsParams' width=150></e-column>
            </e-columns>
        </ejs-grid>
    </div>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Page, Toolbar, Edit } from "@syncfusion/ej2-vue-grids";
import { MultiSelect } from "@syncfusion/ej2-dropdowns";
import { purchaseData } from './datasource.js';

Vue.use(GridPlugin);

let ddElem;
let multiSelectObj;
let multiselectDatasource = [
  { ShipCity: 'Reims', Id: '1' },
  { ShipCity: 'Münster', Id: '2' },
  { ShipCity: 'Rio de Janeiro', Id: '3' },
  { ShipCity: 'Lyon', Id: '4' },
  { ShipCity: 'Charleroi', Id: '5' },
];

function createShipCityFn() {
  ddElem = document.createElement('input');
  return ddElem;
}
function readShipCityFn() {
  return multiSelectObj.value.join(",");
}
function destroyShipCityFn() {
  multiSelectObj.destroy();
}
function writeShipCityFn(args) {
  {
    let multiSelectVal = args.rowData[args.column.field]
      ? args.rowData[args.column.field].split(",")
      : [];
    multiSelectObj = new MultiSelect({
      value: multiSelectVal,
      dataSource: multiselectDatasource,
      fields: { value: "ShipCity", text: "ShipCity" },
      floatLabelType: "Never",
      mode: "Box",
    });
    multiSelectObj.appendTo(ddElem);
  }
}

export default {
  data() {
    return {
      data: purchaseData,
      pageSettings: { pageSizes: true, pageSize: 5 },
      editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
      dsParams: {
        create: createShipCityFn,
        destroy: destroyShipCityFn,
        read: readShipCityFn,
        write: writeShipCityFn,
      },
      toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
      orderIDRules: { required: true },
    };
  },

  provide: {
    grid: [Page, Edit, Toolbar],
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";
</style>

Render MaskedTextBox component while editing

Use the cell edit template feature of the Grid to render the MaskedTextBox component in the Grid edit form. In the following sample, the MaskedTextBox component is rendered in the Mask column.

<template>
    <div id="app">
        <ejs-grid ref='grid' :dataSource='data' :allowPaging='true' :editSettings='editSettings'  :toolbar='toolbar'>
            <e-columns>
                <e-column field='OrderID' headerText='Order ID' type='number' textAlign='Right' :isPrimaryKey='true' width=100></e-column>
                <e-column field='CustomerID' headerText='Customer ID' type='string' width=120>
                </e-column>
                <e-column field='ShipCountry' headerText='Ship Country' type='string' width=120>
                </e-column>
                <e-column field='Mask' headerText='Mask' :edit='params'  width=140>
                </e-column>
            </e-columns>
        </ejs-grid>
    </div>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Page, Toolbar, Edit } from "@syncfusion/ej2-vue-grids";
import { MaskedTextBox } from '@syncfusion/ej2-inputs';
import { employeeData } from './datasource.js';

Vue.use(GridPlugin);

let element;
let maskObj;

function create() {
  element = document.createElement('input');
  return element;
}
function destroy() {
  maskObj.destroy();
}
function read() {
  return maskObj.value;
}
function write(args) {
     maskObj = new MaskedTextBox({
         mask: "0-0-0-0",
        value: args.rowData.Mask
      });
      maskObj.appendTo(element);
}

export default {
  data() {
    return {
      data: employeeData,
      editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
      params: {
        create: create,
        destroy: destroy,
        read: read,
        write: write,
      },
      toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel']
    };
  },
  provide: {
    grid: [Page, Edit, Toolbar],
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";
</style>

Render RichTextEditor component while editing

Use the cell edit template feature of the Grid to render the RichTextEditor component in the Grid edit form. In the below sample, we have rendered RichTextEditor component in the ShipAddress column, so we use allowTextWrap property to true.

<template>
    <div id="app">
        <ejs-grid ref='grid' :dataSource='data' :allowPaging='true' :allowTextWrap='true' :editSettings='editSettings' :pageSettings='pageSettings' :toolbar='toolbar' height='175px' :created='created'>
            <e-columns>
                <e-column field='OrderID' headerText='Order ID' type='number' textAlign='Right' :isPrimaryKey='true' :validationRules='orderIDRules' width=100></e-column>
                <e-column field='CustomerID' headerText='Customer ID' type='string' width=140>
                </e-column>
                <e-column field='Freight' headerText='Freight' type='number' textAlign='Right' editType='numericedit' format='C2' width=120></e-column>
                <e-column field='ShipAddress' headerText='Ship Address' type='string' :edit='ddParams' :valueAccessor='valueAccessor' :disableHtmlEncode='disableHtmlEncode' width=180>
                </e-column>
            </e-columns>
        </ejs-grid>
    </div>
</template>
<script>
import Vue from "vue";
import { purchaseData } from './datasource.js';
import { GridPlugin, Page, Toolbar, Edit } from "@syncfusion/ej2-vue-grids";
import { RichTextEditor, Toolbar as RTEToolbar, Link, Image, HtmlEditor, QuickToolbar } from '@syncfusion/ej2-richtexteditor';

RichTextEditor.Inject(RTEToolbar, Link, Image, HtmlEditor, QuickToolbar);

Vue.use(GridPlugin);

let rteElem;
let richTextEditor;

function createShipAddressFn() {
  rteElem = document.createElement("textarea");
  return rteElem;
}
function destroyShipAddressFn() {
  richTextEditor.destroy();
}
function readShipAddressFn() {
  return richTextEditor.value;
}
function writeShipAddressFn(args) {
  richTextEditor = new RichTextEditor({
    value: args.rowData[args.column.field],
  });
  richTextEditor.appendTo(rteElem);
}

export default {
  data() {
    return {
      data: purchaseData,
      pageSettings: { pageSizes: true, pageSize: 5 },
      disableHtmlEncode: false,
      editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
      ddParams: {
        create: createShipAddressFn,
        destroy: destroyShipAddressFn,
        read: readShipAddressFn,
        write: writeShipAddressFn,
      },
      toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
      orderIDRules: { required: true },
    };
  },
  methods: {
    created(args) {
      this.$refs.grid.ej2Instances.keyConfigs.enter = "";
    },
    valueAccessor: function (field, cdata, column) {
      var value = cdata[field];
      if (value !== undefined) {
        return value.split("\n").join("<br>");
      } else {
        return "";
      }
    },
  },

  provide: {
    grid: [Page, Edit, Toolbar],
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";
</style>

Render multiple columns in DropDownList component while editing

Use the cell edit template feature of the Grid to render the DropDownList component in the Grid edit form.

The DropDownList has been provided with several options to customize each list item, group title, selected value, header, and footer element. By default, list items can be rendered as a single column in the DropDownList component. Instead of this, multiple columns can be rendered. This can be achieved by using the headerTemplate and itemTemplate properties of the DropDownList component.

This is demonstrated in the following sample.

<template>
    <div id="app">
        <ejs-grid ref='grid' :dataSource='data' :allowPaging='true' :editSettings='editSettings'  :toolbar='toolbar'>
            <e-columns>
                <e-column field='OrderID' headerText='Order ID' type='number' textAlign='Right' :isPrimaryKey='true' width=100></e-column>
                <e-column field='CustomerID' headerText='Customer ID' type='string' width=120>
                </e-column>
                <e-column field='ShipCountry' headerText='Ship Country' type='string' :edit='params'  width=300>
                </e-column>
            </e-columns>
        </ejs-grid>
    </div>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Page, Toolbar, Edit } from "@syncfusion/ej2-vue-grids";
import { Query } from '@syncfusion/ej2-data';
import { DropDownList } from '@syncfusion/ej2-dropdowns';
import { data } from './datasource.js';

Vue.use(GridPlugin);

let element;
let dropdownobj;

function create() {
  element = document.createElement('input');
  return element;
}
function destroy() {
  dropdownobj.destroy();
}
function read() {
  return dropdownobj.value;
}
function write(args) {
     dropdownobj = new DropDownList({
         dataSource:data,
         value: args.rowData[args.column.field],
         query: new Query().select(['EmployeeID', 'ShipCountry']).take(10),
         fields: { text: 'ShipCountry', value: 'ShipCountry' },
         placeholder: 'Select a Country',
         headerTemplate: '<table><tr><th>EmployeeID</th><th>ShipCountry</th></tr></table>',
         itemTemplate: '<div class="e-grid"><table class="e-table"><tbody><tr><td class="e-rowcell">${EmployeeID}</td><td class="e-rowcell">${ShipCountry}</td></tr> </tbody></table></div>'
      });
      dropdownobj.appendTo(element);
}

export default {
  data() {
    return {
      data: data,
      editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true },
      params: {
        create: create,
        destroy: destroy,
        read: read,
        write: write,
      },
      toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel']
    };
  },
  provide: {
    grid: [Page, Edit, Toolbar],
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";
    .content {
        margin: 0 auto;
        width: 550px;
    }
    table{
        width:100%;
        border-collapse: separate;
        table-layout: fixed;
    }
    th,td{  
        border-width: 1px 0 0 1px;
        border-color: #e0e0e0;
        text-align: left;
        border-style: solid;
        display: table-cell;
    }
    th{
        line-height: 36px;
        text-indent: 16px;
    }
    .e-ddl-header{
        padding-right: 17px;
        border-width: 1px 0px 1px 0px;
        border-color: #e0e0e0;
        border-style: solid;
    }
    .e-dropdownbase .e-list-item{
        padding-right:0px;
    }
</style>

Using template

The cell editor for a particular column can be specified using a Vue Component. The column.editTemplate property used to define the corresponding column editor.

<template>
    <div id="app">
        <ejs-grid :dataSource='data' :editSettings='editSettings' :toolbar='toolbar' height='273px'>
            <e-columns>
                <e-column field='OrderID' headerText='Order ID' textAlign='Right' :isPrimaryKey='true' width=100></e-column>
                <e-column field='CustomerID' headerText='Customer ID' width=120></e-column>
                <e-column field='Freight' headerText='Freight' textAlign= 'Right' editType= 'numericedit' width=120 format= 'C2'></e-column>
                <e-column field='OrderDate' headerText='Order Date' type='date' format= 'yMd' width=150 :editTemplate='editTemplate'></e-column>
            </e-columns>
        </ejs-grid>
    </div>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Page, Toolbar, Edit } from "@syncfusion/ej2-vue-grids";
import { data } from './datasource.js';
import { DatePickerPlugin } from "@syncfusion/ej2-vue-calendars";

Vue.use(GridPlugin);
Vue.use(DatePickerPlugin);

export default {
  data() {
    return {
      data: data,
      editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Normal' },
      toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel']
    };
  },
  methods: {
      editTemplate: function() {
          return {template: Vue.component('datePicker', {
              template: `<ejs-datepicker id="OrderDate" placeholder="Order Date" v-model="data.OrderDate" floatLabelType='Never'></ejs-datepicker>`,
              data() {
                  return {data:{}}
              }
          })}
      }
  },
  provide: {
    grid: [Page, Edit, Toolbar]
  }
}
</script>

<style>
 @import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";
</style>